/******************************************************************************
* INCLUDES                                                                    *
******************************************************************************/
#include "DetectionFunc.h"
#include "Parameters.h"

/******************************************************************************
* GLOBAL DECLARATIONS                                                         *
******************************************************************************/

int   dim;
int   spint[4]={0,0,0,0};
int targa_i[4]={0,0,0,0};
PIXEL blob[1024];
TARGA targa[1024];

uchar *data;                         //per la negative





int contatore=0;
int targa_s[4]={0,0,0,0};
int HTARGA =      31;    // Height della targa che si vuole prendere
int WTARGA =      133;   // Width della targa che si vuole prendere

int APRX  =       35;    // Approssimazione orizontale della targa secondo la altura nell'immagine
int APRXV =       10;    // Aprossimazione verticale della targa secondo la altura nell'immagine

int SOGLIACOLOR = 10;    // Color mezzo minimo dei quatrati mostrati
int SOGLIA      = 15;    // Soglia dei gradenti

float H[3][3]={ { 0.1734  ,  0.0318, 0.3022},
                {-0.0402  ,  0.2116, 0.8931},
                {-0.0000  ,  0.0000, 0.1832}};// Matrice H necessaria per fare l'homography

unsigned char data1[DIM_X*DIM_Y];
unsigned char data2[DIM_X*DIM_Y];
unsigned char data3[DIM_X*DIM_Y];  // Immagini ausiliari



/******************************************************************************
* GET_L_CLOSURE                                                               *
*                                                                             *
* Returns the width of the window for the erode\dilate function               *
*                                                                             *
******************************************************************************/

int get_l_closure(){
    return l_closure;
}

/******************************************************************************
* GET_N_CLOSURE                                                               *
*                                                                             *
* Returns the hight of the window for the erode\dilate function               *
*                                                                             *
******************************************************************************/
int get_n_closure(){
    return n_closure;
}

/******************************************************************************
* TRANSFORM                                                                   *
*                                                                             *
* Performs a homogeneous transformation on the input image file, in order to  *
* have the licence plate in a rectangle of standard dimentions.               *
*                                                                             *
* *************************************************************************** *
*                                                                             *
* @param  image       image to be transformed                                 *
* @param  matrix      matrix for the transformation                           *
* @param  transformed support array                                        *
*                                                                             *
******************************************************************************/
uchar* transform(uchar* image,uchar* transformed, int dim_x, int dim_y){

       int i,j;
       int dim_X, dim_Y, dim_T;
       float temp_p, temp_q, a, e, val;
       int temp_y, temp_x;
       
       //dim_X = (int) (matrix[0] * dim_x + matrix[1] * dim_y + matrix[2]);
       //dim_Y = (int) (matrix[3] * dim_x + matrix[4] * dim_y + matrix[5]);

       dim_X = 640;
       dim_Y = 480;
       dim_T = dim_X * dim_Y;
       
       for (j=0; j<dim_Y; j++){
         for (i=0; i<dim_X; i++){
           temp_p = (float)(invmatrix[0]*i+invmatrix[1]*j+invmatrix[2]);
           temp_x=(int)temp_p;
           a=temp_p-temp_x;
           if (temp_x >= dim_X) temp_x = dim_X-1;
           else if(temp_x <= 0) temp_x = 0;
           temp_q = (float)(invmatrix[3]*i+invmatrix[4]*j+invmatrix[5]);
           temp_y=(int)temp_q;
           e=temp_q-temp_y;
           if (temp_y >= dim_Y) temp_y = dim_Y-1;
           else if(temp_y <= 0) temp_y = 0;
           
           val=image[temp_y*dim_x + temp_x]*(1-a)*(1-e)+image[temp_y*dim_x + temp_x+1]*(a)*(1-e)+image[(temp_y+1)*dim_x + temp_x]*(1-a)*(e)+image[(temp_y+1)*dim_x + temp_x+1]*(a)*(e);
           transformed[dim_X*j + i] = (int)val;
         }
           
       }
       
       return transformed;
}



/******************************************************************************
* EQUALIZATION                                                                *
*                                                                             *
* Equalization function applies an equalization to the original image.        *
* This operation is very useful expecially on dark images, where the          *
* hystogram's components are mostly near the dark grey colors.                *
* The equalization increase the contrast, and the values will be spread more, *
* leading to a better defined image, and clearer.                             *
*                                                                             *
* The function creates an hystogram array of 256 cells, for all grey values,  *
* in which will be stored the percentage of each value in the image.          *
* Another array will be created, in which there will be the incremental sum.  *
* of the values for each cell of the first array.                             *
* The result is a number between 0 and 1, that is multiplied by 255 to obtain *
* a value in the grey scale.                                                  *
* The last step is to modify the original image using the value of the second *
* array.                                                                      *
*                                                                             *
* *************************************************************************** *
* @param  equalized   image to be equalized                                   *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
******************************************************************************/

uchar* equalization(uchar* equalized, int dim_x, int dim_y)
{
  return equalized;
  
  
  int i,temp,count;
  float histogram[256]; //array per memorizzare l'istogramma della fotografia
  float equalization_op [256];  //array per memorizzare i valori da assegnare all'immagine per equalizzarla

  temp=0;
  dim=dim_x*dim_y;

  for(i=0;i<256;i++)
  {
    histogram[i]=0;   //inizializzo l'array istogramma a 0
  }

  for(i=0;i<dim;i++)
  {
      temp=equalized[i];  //copio in temp il valore originale della foto che utilizzo come indice per posizionarmi in histogram
      count=(int)histogram[temp]+1; //conto il numero di volte che ho incontrato nella fotografia un determinato valore
      histogram[temp]=(float)count; //lo copio in histogram nella posizione data dal valore della fotografia originale
  }

  for(i=0;i<256;i++)
  {
    histogram[i]=histogram[i]/dim;  //ho trovato l'istogramma dell'immagine   
  }
  
  equalization_op[0]=histogram[0];

  for(i=1;i<256;i++)
  {
    equalization_op[i]=equalization_op[i-1]+histogram[i]; //sommatoria per creare l'array equalizzazione
  }

  for(i=0;i<dim;i++)
  {
    temp=equalized[i];  //assegno a temp il valore della fotografia originale per poi andare in equalization_op all'indice corrispondente
    equalized[i]=(int)(equalization_op[temp]*255);  //modifico la fotografia con il valore presente in equalization_op all'indice corrispondente
  }

  return equalized;
}



/******************************************************************************
* CONVOLUTION                                                                 *
*                                                                             *
* Convolution function applies a convolution process to the original image.   *
* This operation makes the image less "noisy".                                *
*                                                                             *
* The function does two sequential convolution:                               *
* - horizontal                                                                *
* - vertical                                                                  *
*                                                                             *
* The last step is to weight every pixel wrt the neighbors, using a           *
* Gaussian function.                                                          *
*                                                                             *
* *************************************************************************** *
* @param  convoluted  image to be convoluted                                  *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
******************************************************************************/

uchar* convolution(uchar* convoluted, int dim_x, int dim_y)
{
  int i,j,a,b,c,d,x;
  int index;
  float y;
  double pi,temp,sigma;
  double convolution_array [21];  //per inserire i valori della gaussiana
  double image_pixel [21];  //uguale al convolution array
  
  int w=0;
  int h=0;
    
  pi=3.14159;
  dim=dim_x*dim_y;
  x=x_gauss;  //distanza dal centro della gaussiana
  y=(float)x;
  sigma=ceil((y+1)/3);  //calcolo di sigma
  convolution_array[x]=(1/(sigma*sqrt(2*pi)));  //inizializzazione del valore centrale della gaussiana
  
  for(j=x-1;j>=0;j=j-1) //trovo i valori della gaussiana
  {
    convolution_array[j]=(1/(sigma*sqrt(2*pi)))*exp((-1)*((pow((x-j),2))/(2*pow(sigma,2))));
    
    convolution_array[x+x-j]=convolution_array[j];
  }

  while (w<dim_y) //scorro tutte le righe dell'immagine
  {
    for(i=(dim_x*w)+x;i<=(dim_x*w)+dim_x -x-1;i++)  //scorre tutte le finestre create
    {
      index=x;  //centro della gaussiana
      image_pixel[index]=convoluted[i]; //a met dell'array di supporto, metto il valore della foto originale

      for(a=i-1; a>=i-x; a=a-1) //inserisco i valori nella parte sx dell'array di supporto, in totale x valori
      {
        index=index-1;
        image_pixel[index]=convoluted[a];
      }

      index=x;  //posizione centrale della gaussiana
      for(b=i+1;b<=(i+x);b++) //inserisco i valori nella parte dx dell'array di supporto, x valori
      {
        index=index+1;
        image_pixel[index]=convoluted[b];
      }//ho creato la finestra dell'immagine originale con cui applicare la convoluzione al pixel centrale
      
      for(c=0;c<=(2*x);c++) //moltiplico image_pixel e convolution_array, valore di un array per il corrispondente nell'altro
      {
        image_pixel[c]=(image_pixel[c]*convolution_array[c]);
      }

      temp=image_pixel[0];

      for(d=1;d<=(2*x);d++)
      {
        temp=temp+image_pixel[d]; //sommatoria dei valori dell'array
      }

      convoluted[i]=(uchar)temp;  //modifico il pixel della foto originale con il valore convoluto
    }

    w++;  //scorro nella colonna a destra
  }

  while(h<dim_x)  //stesso procedimento applicato verticalmente sull'immagine gi modificata
  {
    for(i=(dim_x*x)+h;i<=dim-(dim_x*(x+1))+h;i=i+dim_x) //scorre tutte le finestre create
    {
      index=x;
      image_pixel[index]=convoluted[i]; //a met dell'array di supporto, cio in posizione x, inserisco il valore della foto originale

      for(a=i-dim_x; a>=i-(dim_x*x); a=a-dim_x) //inserisco i valori nella parte sx dell'array di supporto, in totale x valori
      {
        index=index-1;
        image_pixel[index]=convoluted[a];
      }

      index=x;  //posizione centrale del supporto

      for(b=i+dim_x;b<=i+(dim_x*x);b=b+dim_x) //inserisco i valori nella parte dx dell'array di supporto, x valori
      {
        index=index+1;
        image_pixel[index]=convoluted[b];
      }//ho creato la finestra dell'immagine originale con cui applicare la convoluzione al pixel centrale
      
      for(c=0;c<=(2*x);c++)
      {
        image_pixel[c]=(image_pixel[c]*convolution_array[c]); 
      }

      temp=image_pixel[0];

      for(d=1;d<=(2*x);d++)
      {
        temp=temp+image_pixel[d];
      }

      convoluted[i]=(uchar)temp;
    }

    h++;
  }

  return convoluted;
}


/******************************************************************************
* DILATE                                                                      *
*                                                                             *
* Dilate function applies a dilation the image.                               *
* It uses the van Herk/Gil-Werman algorithm for the grey level morphology.    *
* http://www.leptonica.com/grayscale-morphology.html                          *
*                                                                             *
* *************************************************************************** *
* @param  image       image where to apply the dilation                       *
* @param  half_dilate support array                                           *
* @param  dilate_out  support array where to store the modified image         *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
* @param  l           width  of the dilation window                           *
* @param  n           height of the dilation window                           *
******************************************************************************/

uchar* dilate(uchar* image, uchar* half_dilate, uchar* dilate_out, int dim_x, int dim_y, int l, int n)
{
  //clock_t start, end;
  //double dif;

  int num_of_groups;  //numero di finestre in cui la fotografia  divisa
  int last_window;  //dimensione dell'ultima finestra da creare dinamicamente
  int i,j,a,b,c,d,t,index;
  int w=0;  //riga 0
  int h=0;  //colonna 0
  uchar supporto[FIN_MASK];  //grandezza definita da (2*L+1).impostato a 203 per utilizzare finestre fino a 101 pixel
  
  dim=dim_x*dim_y;
  num_of_groups=dim_x/l;    // un numero intero  ---> larghezza foto/laghezza finestra
  index=l;  //posizione centrale dell'array di supporto
  
  //-----------------------------------------------------------------------------------------------------------------
  //calcolo delle finestre orizzontali

  while (w<dim_y) //scorro tutte le righe dell'immagine
  {
    i=(dim_x*w)+l/2;  //il pixel centrale della prima finestra di ogni ogni riga

    for(j=1;j<num_of_groups+1;j++)  //scorre tutte le finestre create
    {
      index=l;  // il pixel centrale dell'array di supporto
      
      supporto[index]=image[i]; //a met dell'array di supporto, cio in posizione L, metto il pixel centrale della finestra

      for(a=i-1; a>=(dim_x*w)+(l*(j-1))-(l/2)-1; a=a-1) //inserisco i valori nella parte sx dell'array di supporto, in totale L valori
      {
        if(a<(dim_x*w)) //esco dal margine sinistro della foto
        {
          supporto[index-1]=supporto[index];
        }

        else 
        {
          if(image[a]>supporto[index])  //confronto il pixel corrente con quello alla sua dx gi inserito 
                          //nell'array di supporto nella posizione seguente rispetto alla corrente.
                          //se  maggiore inserisco il valore del pixel considerato nell'array 
                          //di supporto nella posizione corrente, altrimenti propago a sx il 
                          //valore presente nell'array di supporto
          {
            supporto[index-1]=image[a];
          }
        else supporto[index-1]=supporto[index];
        }
        index=index-1;
      }

      index=l;  //posizione centrale del supporto

      for(b=i+1;b<=(i+l);b++) //inserisco i valori nella parte dx dell'array di supporto, L valori
      {
        if(b>(w*dim_x)+dim_x-1) //esco dal margine destro della foto
        {
          supporto[index+1]=supporto[index];
        }
        
        else 
        {
          if(image[b]>supporto[index])  //confronto il pixel corrente con quello alla sua sx gi inserito 
                          //nell'array di supporto nella posizione precedente a quella corrente.
                          //se  maggiore inserisco il valore del pixel considerato nell'array 
                          //di supporto nella posizione corrente,altrimenti propago a dx 
                          //il valore presente nell'array di supporto
          {
            supporto[index+1]=image[b];
          }
          else supporto[index+1]=supporto[index];
        }
        index=index+1;
      }
      
      index=0;  //all'inizio dell'array di supporto

      for(c=(dim_x*w)+(l*(j-1));c<=(dim_x*w)+(l*j)-1;c++) //parto da 0 per modificare l'immagine considerando
                                //i pixel nella finestra corrispondente, e scorro tutto 
                                //il gruppo di pixel
      {
        if(supporto[index]>supporto[index+l]) //confronto i pixel a distanza l, cio la dimensione della finestra
        {
          half_dilate[c]=supporto[index]; //inserisco il pixel max nell'array in cui memorizzo la fotografia a met dilate
        }
        else half_dilate[c]=supporto[index+l];
      
        index=index+1;
      }
      i=i+l;  //mi sposto nel pixel centrale della finestra a destra
    }

    last_window=dim_x-(num_of_groups*l);  //dimensione dell'ultima finestra
      if((last_window%2)==0)  //per evitare che l'ultima finestra sia pari
        {
          last_window=last_window+1;
        }

      i=(dim_x*w)+(num_of_groups*l)+(last_window/2)-1;  //posizione centrale dell'ultima finestra

      index=last_window;

      supporto[index]=image[i];
    
      for(a=i-1; a>=i-last_window; a=a-1) //inserisco i valori nella parte sx dell'array di supporto, 
                        //in totale Last_window valori
        {
          if(image[a]>supporto[index])  //confronto il pixel corrente con quello alla sua dx gi inserito 
                          //nell'array di supporto nella posizione seguente rispetto alla corrente.
                          //se  maggiore inserisco il valore del pixel considerato nell'array 
                          //di supporto nella posizione corrente, altrimenti propago a sx il 
                          //valore presente nell'array di supporto
          {
            supporto[index-1]=image[a];
          }
          else supporto[index-1]=supporto[index];
        
          index=index-1;
        }
        
      index=last_window;  //posizione centrale del supporto

      for(b=i+1;b<=(i+last_window);b++) //inserisco i valori nella parte dx dell'array di supporto
        {
          if(b>(w*dim_x)+dim_x-1) //esco dal margine destro della foto
          {
            supporto[index+1]=supporto[index];
          }
        
          else 
          {
            if(image[b]>supporto[index])  //confronto il pixel corrente con quello alla sua sx gi inserito 
                            //nell'array di supporto nella posizione precedente a quella corrente.
                            //se  maggiore inserisco il valore del pixel considerato nell'array 
                            //di supporto nella posizione corrente,altrimenti propago a dx 
                            //il valore presente nell'array di supporto
            {
              supporto[index+1]=image[b];
            }
            else supporto[index+1]=supporto[index];
          }
          index=index+1;
        }
      
        index=0;  //all'inizio dell'array di supporto

      for(d=i-(last_window/2);d<=i+(last_window/2);d++) //parto dal primo pixel dell'ultima finestra per modificare
                            //l'immagine considerando i pixel nella finestra corrispondente, e scorro tutto 
                            //il gruppo di pixel
        {
          if(supporto[index]>supporto[index+last_window]) //confronto i pixel a distanza last_window, cio la dimensione della finestra
          {
            half_dilate[d]=supporto[index]; //inserisco il pixel max nell'array in cui memorizzo la fotografia a met dilate
          }

          else half_dilate[d]=supporto[index+last_window];
      
          index=index+1;
        }
    
    w++;  //scorro nella colonna a destra
  }
  //fine calcolo finestre orizzontali
  //-------------------------------------------------------------------------------------------------------------
  
  //ora si calcola il max in una finestra verticale ed il valore sar poi quello memorizzato al termine della dilate
  
  num_of_groups=dim_y/n;    // un numero intero --> altezza fotografia/altezza finestr
  index=n;    //posizione centrale dell'array di supporto
  i=(n/2)*dim_x;    //pixel centrale della prima finestra
  
  last_window=dim_y-(num_of_groups*n);  //dimensione dell'ultima finestra
  if((last_window%2)==0)  //per evitare che l'ultima finestra sia pari
    {
        last_window=last_window+1;
    }

  t=((num_of_groups*n)*dim_x)+(dim_x*(last_window/2))-dim_x;  //posizione centrale dell'ultima finestra
  while (h<dim_x) //scorro tutte le colonne dell'immagine
  {
    for(j=1;j<num_of_groups+1;j++)  //scorro tutte le finestre create
    {
      index=n;  //posizione centrale dell'array di supporto
      
      supporto[index]=half_dilate[i]; //a met dell'array di supporto, cio in posizione N

      for(a=i-dim_x; a>=i-(n*dim_x); a=a-dim_x) //inserisco i valori nella parte sx dell'array di supporto, in totale N valori
      {
        if(a<0) //esco dalla fotografia nella parte alta della prima colonna
        {
          supporto[index-1]=supporto[index];
        }

        else 
        {
          if(half_dilate[a]>supporto[index])  //confronto il pixel corrente con quello alla sua dx gi inserito 
                            //nell'array di supporto nella posizione seguente rispetto alla corrente.
                            //se  maggiore inserisco il valore del pixel considerato nell'array 
                            //di supporto nella posizione corrente, altrimenti propago a sx il 
                            //valore presente nell'array di supporto
          {
            supporto[index-1]=half_dilate[a];
          }
        else supporto[index-1]=supporto[index];
        }

        index=index-1;
      }

      index=n;  //posizione centrale dell'array di supporto

      for(b=i+dim_x;b<=i+(n*dim_x);b=b+dim_x) //inserisco i valori nella parte dx dell'array di supporto, n valori
      {
        if(b>dim-1)
        {
          supporto[index+1]=supporto[index];
        }
        
        else 
        {
          if(half_dilate[b]>supporto[index])  //confronto il pixel corrente con quello alla sua sx gi inserito 
                            //nell'array di supporto nella posizione seguente rispetto alla corrente.
                            //se  maggiore inserisco il valore del pixel considerato nell'array 
                            //di supporto nella posizione corrente, altrimenti propago a dx il 
                            //valore presente nell'array di supporto
          {
            supporto[index+1]=half_dilate[b];
          }
          else supporto[index+1]=supporto[index];
        }

        index=index+1;
      }
      
      index=0;  //all'inizio dell'array di supporto

      for(c=h+((n*dim_x)*(j-1));c<=h+((n*dim_x)*(j-1))+(n*dim_x)-dim_x;c=c+dim_x) 
                          //parto da 0 per modificare l'immagine considerando i pixel 
                          //nella finestra corrispondente, e scorro tutto il gruppo di pixel
      {
        if(supporto[index]>supporto[index+n]) //confronto i pixel a distanza n, cio la dimensione della finestra
        {
          dilate_out[c]=supporto[index];  //inserisco il pixel max nell'array in cui memorizzo la fotografia finale
        }
        else dilate_out[c]=supporto[index+n];
      
        index=index+1;
      }
      i=i+(n*dim_x);  //mi posiziono nel pixel centrale della finestra successiva
    }
        
      index=last_window;
      
      supporto[index]=image[t];
      for(a=t-dim_x; a>=t-(dim_x*last_window); a=a-dim_x) //inserisco i valori nella parte sx dell'array di supporto, 
                        //in totale Last_window valori
        {
          if(image[a]>supporto[index])  //confronto il pixel corrente con quello alla sua dx gi inserito 
                          //nell'array di supporto nella posizione seguente rispetto alla corrente.
                          //se  maggiore inserisco il valore del pixel considerato nell'array 
                          //di supporto nella posizione corrente, altrimenti propago a sx il 
                          //valore presente nell'array di supporto
          {
            supporto[index-1]=image[a];
          }
          else supporto[index-1]=supporto[index];
        
          index=index-1;
        }
        
      index=last_window;  //posizione centrale del supporto

      for(b=t+dim_x;b<=t+(last_window*dim_x);b=b+dim_x) //inserisco i valori nella parte dx dell'array di supporto
        {
          if(b>dim-1) //esco dal margine basso della foto
          {
            supporto[index+1]=supporto[index];
          }
        
          else 
          {
            if(image[b]>supporto[index])  //confronto il pixel corrente con quello alla sua sx gi inserito 
                            //nell'array di supporto nella posizione precedente a quella corrente.
                            //se  maggiore inserisco il valore del pixel considerato nell'array 
                            //di supporto nella posizione corrente,altrimenti propago a dx 
                            //il valore presente nell'array di supporto
            {
              supporto[index+1]=image[b];
            }
            else supporto[index+1]=supporto[index];
          }
          index=index+1;
        }
      
        index=0;  //all'inizio dell'array di supporto
      for(d=t-(dim_x*(last_window/2));d<=t+(dim_x*(last_window/2));d=d+dim_x) //parto dal primo pixel dell'ultima finestra per modificare
                            //l'immagine considerando i pixel nella finestra corrispondente, e scorro tutto 
                            //il gruppo di pixel
        {
          if(supporto[index]>supporto[index+last_window]) //confronto i pixel a distanza last_window, cio la dimensione della finestra
          {
            half_dilate[d]=supporto[index]; //inserisco il pixel max nell'array in cui memorizzo la fotografia a met dilate
          }

          else half_dilate[d]=supporto[index+last_window];
      
          index=index+1;
        }

    i=i+1-((n*dim_x)*(num_of_groups));  //mi posiziono nel pixel centrale della prima finestra di ogni colonna
    t=t+1;  //mi sposto nella posizione centrale dell'ultima finestradi ogni colonna
    h++;  //mi sposto nella colonna a dx
  }
  
  /*end=clock();
  dif=(double)(end-start)/CLOCKS_PER_SEC;
  printf("%.3f per fare la dilate",dif);
  getchar();*/

  return dilate_out;  //la funzione ritorna l'array in cui  memorizzata la dilate,da usare come primo array di ingresso
            //per la erode
}


/******************************************************************************
* ERODE                                                                       *
*                                                                             *
* Erode function does the erosion to the input image.                         *
* It uses the van Herk/Gil-Werman algorithm for the grey level morphology.    *
* http://www.leptonica.com/grayscale-morphology.html                          *
*                                                                             *
* *************************************************************************** *
* @param  erode_in    image where to apply the erosion                        *
* @param  half_erode  support array                                           *
* @param  erode_out   support array where to store the modified image         *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
* @param  l           width  of the dilation window                           *
* @param  n           height of the dilation window                           *
******************************************************************************/

uchar* erode(uchar* erode_in, uchar* half_erode, uchar* erode_out, int dim_x, int dim_y, int l, int n)
{
  //clock_t start_E, end_E;
  //double dif_E;

  int num_of_groups;  //numero di finestre in cui la fotografia  divisa
  int last_window;
  int i,j,a,b,c,d,t,index;
  int w=0;
  int h=0;
  uchar supporto[FIN_MASK];  //grandezza definita da (2*L+1).impostato a 203 per utilizzare finestre fino a 101 pixel
  
  //start_E=clock();

  dim=dim_x*dim_y;

  num_of_groups=dim_x/l;    // un numero intero  ---> larghezza foto/laghezza finestra
  index=l;  //posizione centrale dell'array di supporto
  
  //-----------------------------------------------------------------------------------------------------------------
  //calcolo delle finestre orizzontali

  while (w<dim_y) //scorro tutte le righe dell'immagine
  {
    i=(dim_x*w)+l/2;  //il pixel centrale della prima finestra di ogni ogni riga
    
    for(j=1;j<num_of_groups+1;j++)  //scorre tutte le finestre create
    {
      index=l;  // il pixel centrale dell'array di supporto
      
      supporto[index]=erode_in[i];  //a met dell'array di supporto, cio in posizione L

      for(a=i-1; a>=(dim_x*w)+(l*(j-1))-(l/2)-1; a=a-1) //inserisco i valori nella parte sx dell'array di supporto, in totale L valori
      {
        if(a<(dim_x*w)) //esco dal margine sinistro della foto
        {
          supporto[index-1]=supporto[index];
        }

        else 
        {
          if(erode_in[a]<supporto[index]) //confronto il pixel corrente con quello alla sua dx gi inserito 
                          //nell'array di supporto nella posizione seguente rispetto alla corrente.
                          //se  minore inserisco il valore del pixel considerato nell'array 
                          //di supporto nella posizione corrente, altrimenti propago a sx il 
                          //valore presente nell'array di supporto
          {
            supporto[index-1]=erode_in[a];
          }
          else supporto[index-1]=supporto[index];
        }
        index=index-1;
      }

      index=l;  //posizione centrale dell'array di supporto

      for(b=i+1;b<=(i+l);b++) //inserisco i valori nella parte dx dell'array di supporto, L valori
      {
        if(b>(w*dim_x)+dim_x-1) //esco dal margine destro della foto
        {
          supporto[index+1]=supporto[index];
        }
        
        else 
        {
          if(erode_in[b]<supporto[index]) //confronto il pixel corrente con quello alla sua sx gi inserito 
                          //nell'array di supporto nella posizione seguente rispetto alla corrente.
                          //se  minore inserisco il valore del pixel considerato nell'array 
                          //di supporto nella posizione corrente, altrimenti propago a dx il 
                          //valore presente nell'array di supporto
          {
            supporto[index+1]=erode_in[b];
          }
          else supporto[index+1]=supporto[index];
        }
        index=index+1;
      }

      index=0;  //all'inizio dell'array di supporto

      for(c=(dim_x*w)+(l*(j-1));c<=(dim_x*w)+(l*j)-1;c++) //parto da L/2+1 per modificare l'immagine considerando
                                //i pixel nella finestra corrispondente, e scorro tutto il gruppo di pixel
      {
        if(supporto[index]<supporto[index+l]) //confronto i pixel a distanza l, cio la dimensione della finestra
        {
          half_erode[c]=supporto[index];  //inserisco il pixel min nell'array in cui memorizzo la fotografia a met erode
        }
        else half_erode[c]=supporto[index+l];
      
        index=index+1;
      }
      i=i+l;  //mi sposto nel pixel centrale della finestra a destra
    }
    
    last_window=dim_x-(num_of_groups*l);
    
      if((last_window%2)==0)  //per evitare che l'ultima finestra sia pari
        {
          last_window=last_window+1;
        }

      i=(dim_x*w)+(num_of_groups*l)+(last_window/2)-1;  //posizione centrale dell'ultima finestra
    
      index=last_window;
    
      supporto[index]=erode_in[i];
    
      for(a=i-1; a>=(dim_x*w)+(l*num_of_groups)-(last_window/2)-1; a=a-1) //inserisco i valori nella parte sx dell'array di supporto
        {
          if(erode_in[a]<supporto[index]) //confronto il pixel corrente con quello alla sua dx gi inserito 
                          //nell'array di supporto nella posizione seguente rispetto alla corrente.
                          //se  maggiore inserisco il valore del pixel considerato nell'array 
                          //di supporto nella posizione corrente, altrimenti propago a sx il 
                          //valore presente nell'array di supporto
          {
            supporto[index-1]=erode_in[a];
          }
          else supporto[index-1]=supporto[index];
    
          index=index-1;
        }
      
      index=last_window;  //posizione centrale del supporto

      for(b=i+1;b<=(i+(last_window/2));b++) //inserisco i valori nella parte dx dell'array di supporto
        {
          if(b>(w*dim_x)+dim_x-1) //esco dal margine destro della foto
          {
            supporto[index+1]=supporto[index];
          }
        
          else 
          {
            if(erode_in[b]<supporto[index]) //confronto il pixel corrente con quello alla sua sx gi inserito 
                            //nell'array di supporto nella posizione precedente a quella corrente.
                            //se  maggiore inserisco il valore del pixel considerato nell'array 
                            //di supporto nella posizione corrente,altrimenti propago a dx 
                            //il valore presente nell'array di supporto
            {
              supporto[index+1]=erode_in[b];
            }
            else supporto[index+1]=supporto[index];
          }
          index=index+1;
        }
      
      index=0;  //all'inizio dell'array di supporto

      for(d=i-(last_window/2);d<=i+(last_window/2);d++) //parto dal primo pixel dell'ultima finestra per modificare
                                  //l'immagine considerando i pixel nella finestra corrispondente, e scorro tutto 
                                  //il gruppo di pixel
        {
          if(supporto[index]<supporto[index+last_window]) //confronto i pixel a distanza last_window, cio la dimensione della finestra
          {
            half_erode[d]=supporto[index];  //inserisco il pixel max nell'array in cui memorizzo la fotografia a met dilate
          }
          else half_erode[d]=supporto[index+last_window];
      
          index=index+1;
        }
    
    w++;  //mi sposto nella colonna a destra
  }
  //fine calcolo delle finestre orizzontali
  //-----------------------------------------------------------------------------------------------------------------------
  
  
  //ora calcolo il minimo di ogni finestra verticale ed il valore sar quello finale memorizzato al termine della closure

  num_of_groups=dim_y/n;    // un numero intero  --> altezza fotografia/altezza finestra
  index=n;  //posizione centrale dell'array di supporto
  i=(n/2)*dim_x;  //pixel centrale della prima finestra nella prima colonna
  last_window=dim_y-(num_of_groups*n);  //dimensioni ultima finestra
    
  if((last_window%2)==0)  //per evitare che l'ultima finestra sia pari
  {
    last_window=last_window+1;
  }

  t=((num_of_groups*n)*dim_x)+(dim_x*(last_window/2))-dim_x;  //posizione centrale dell'ultima finestra della prima colonna


  while (h<dim_x) //scorro tutte le colonne dell'immagine
  {
    for(j=1;j<num_of_groups+1;j++)  //scorro tutte le finestre create
    {
      index=n;  // il pixel centrale dell'array di supporto
      
      supporto[index]=half_erode[i];  //a met dell'array di supporto, cio in posizione N

      for(a=i-dim_x; a>=i-(n*dim_x); a=a-dim_x) //inserisco i valori nella parte sx dell'array di supporto, in totale N valori
      {
        if(a<0) //esco dall'immagine nella parte alta della prima colonna
        {
          supporto[index-1]=supporto[index];
        }

        else 
        {
          if(half_erode[a]<supporto[index]) //confronto il pixel corrente con quello alla sua dx gi inserito 
                            //nell'array di supporto nella posizione seguente rispetto alla corrente.
                            //se  minore inserisco il valore del pixel considerato nell'array 
                            //di supporto nella posizione corrente, altrimenti propago a sx il 
                            //valore presente nell'array di supporto
          {
            supporto[index-1]=half_erode[a];
          }
        else supporto[index-1]=supporto[index];
        }

        index=index-1;
      }

      index=n;  //posizione centrale dell'array di supporto

      for(b=i+dim_x;b<=i+(n*dim_x);b=b+dim_x) //inserisco i valori nella parte dx dell'array di supporto, n valori
      {
        if(b>dim-1) //esco dalla fotografia nella parte bassa dell'ultima colonna
        {
          supporto[index+1]=supporto[index];
        }
        
        else 
        {
          if(half_erode[b]<supporto[index]) //confronto il pixel corrente con quello alla sua sx gi inserito 
                            //nell'array di supporto nella posizione seguente rispetto alla corrente.
                            //se  minore inserisco il valore del pixel considerato nell'array 
                            //di supporto nella posizione corrente, altrimenti propago a dx il 
                            //valore presente nell'array di supporto
          {
            supporto[index+1]=half_erode[b];
          }
          else supporto[index+1]=supporto[index];
        }

        index=index+1;
      }
      
      index=0;  //posizione iniziale dell'array di supporto

      for(c=h+((n*dim_x)*(j-1));c<=h+((n*dim_x)*(j-1))+(n*dim_x)-dim_x;c=c+dim_x) 
                      //parto da 0 per modificare l'immagine considerando
                      //i pixel nella finestra corrispondente, e scorro tutto il gruppo di pixel
      {
        if(supporto[index]<supporto[index+n]) //confronto i pixel a distanza n, cio la dimensione della finestra
        {
          erode_out[c]=supporto[index]; //inserisco il pixel max nell'array in cui memorizzo la fotografia finale
        }
        else erode_out[c]=supporto[index+n];
      
        index=index+1;
      }
      i=i+(n*dim_x);  //mi posiziono nel pixel centrale della finestra successiva
    }

    
      index=last_window;

      supporto[index]=half_erode[t];
    
      for(a=t-dim_x; a>=t-(dim_x*last_window); a=a-dim_x) //inserisco i valori nella parte sx dell'array di supporto, 
                        //in totale Last_window valori
        {
          if(half_erode[a]<supporto[index]) //confronto il pixel corrente con quello alla sua dx gi inserito 
                          //nell'array di supporto nella posizione seguente rispetto alla corrente.
                          //se  maggiore inserisco il valore del pixel considerato nell'array 
                          //di supporto nella posizione corrente, altrimenti propago a sx il 
                          //valore presente nell'array di supporto
          {
            supporto[index-1]=half_erode[a];
          }
          else supporto[index-1]=supporto[index];
        
          index=index-1;
        }
        
      index=last_window;  //posizione centrale del supporto

      for(b=t+dim_x;b<=t+(last_window*dim_x);b=b+dim_x) //inserisco i valori nella parte dx dell'array di supporto
      {
          if(b>dim-1) //esco dal margine basso della foto
          {
            supporto[index+1]=supporto[index];
          }
        
          else 
          {
            if(half_erode[b]<supporto[index]) //confronto il pixel corrente con quello alla sua sx gi inserito 
                            //nell'array di supporto nella posizione precedente a quella corrente.
                            //se  maggiore inserisco il valore del pixel considerato nell'array 
                            //di supporto nella posizione corrente,altrimenti propago a dx 
                            //il valore presente nell'array di supporto
            {
              supporto[index+1]=half_erode[b];
            }
            else supporto[index+1]=supporto[index];
          }
          index=index+1;
        }
      
        index=0;  //all'inizio dell'array di supporto

      for(d=t-(dim_x*(last_window/2));d<=t+(dim_x*(last_window/2));d=d+dim_x) //parto dal primo pixel dell'ultima finestra per modificare
                            //l'immagine considerando i pixel nella finestra corrispondente, e scorro tutto 
                            //il gruppo di pixel
        {
          if(supporto[index]<supporto[index+last_window]) //confronto i pixel a distanza last_window, cio la dimensione della finestra
          {
            erode_out[d]=supporto[index]; //inserisco il pixel max nell'array in cui memorizzo la fotografia a met dilate
          }

          else erode_out[d]=supporto[index+last_window];
      
          index=index+1;
        }

    i=i+1-((n*dim_x)*(num_of_groups));  //mi posiziono nel pixel centrale della prima finestra di ogni colonna
    t=t+1;  //mi sposto nel pixel centrale dell'ultima finestra di ogni colonna
    h++;  //mi sposto nella colonna a dx
  }

  /*end_E=clock();
  dif_E=(double)(end_E-start_E)/CLOCKS_PER_SEC;
  printf("%3f per fare l'erode",dif_E);
  getchar();*/

  return erode_out; //la funzione ritorna l'array in cui  memorizzata la erode,quindi al termine della closure
}


/******************************************************************************
* WHITE MASK                                                                  *
*                                                                             *
* White Mask does the closure (dilation and erosion) to the input image.      *
* Using the white mask the licence plate results uniformly white.             *
* It isolates the areas of the image with most white pixels, inbetween        *
* thin black lines.                                                           *
*                                                                             *
* *************************************************************************** *
* @param  image1      image where to apply the closure                        *
* @param  half        support array                                           *
* @param  end_out     support array where to store the modified image         *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
* @param  l           width  of the dilation window                           *
* @param  n           height of the dilation window                           *
******************************************************************************/

uchar*  whiteMask(uchar* image1, uchar* half, uchar* end_out, int dim_x, int dim_y, int l, int n)
{ 
  printf("\nWhite mask");
  end_out = dilate(image1,half,end_out,dim_x,dim_y, l, n);
  image1=erode(end_out,half,image1,dim_x,dim_y, l, n);
  
  return image1;  //la funzione ritorna l'array in cui  memorizzata la White Mask
}


/******************************************************************************
* NEGATIVE                                                                    *
*                                                                             *
* Negative function creates the complementary image (255 - original value)    *
*                                                                             *
* *************************************************************************** *
* @param  image1      image to convert                                        *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
******************************************************************************/

int negative(uchar* src, int x, int y)  //per fare la foto negativa da usare come originale per la black mask
{
  int j;
  int i;

  data = src;   //per mettere i pixel dell'immagine in un array
  j=x * y;    //dimensioni dell'immagine
  
  for (i=0; i<j; i++)
  {
    data[i]=255-data[i];    //negativo dell'immagine
  }

  return 0;
}



/******************************************************************************
* BLACK MASK                                                                  *
*                                                                             *
* Black Mask does the final closure to the input image.                       *
* Using the white mask the licence plate results only white because the       *
* characters of the licence plate are filtered.                               *
* It isolates the areas of the image with most dark pixels                    *
*                                                                             *
* *************************************************************************** *
* @param  image2      image where to apply the closure                        *
* @param  half        support array                                           *
* @param  end_out     support array where to store the modified image         *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
* @param  l           width  of the dilation window                           *
* @param  n           height of the dilation window                           *
******************************************************************************/

uchar* blackMask(uchar* image2, uchar* half, uchar* end_out, int dim_x, int dim_y, int l, int n)
{
  printf("\nBlack mask");
  negative(image2, dim_x, dim_y);
  end_out = dilate(image2, half, end_out, dim_x, dim_y, l, n);
  image2 = erode(end_out, half, image2, dim_x, dim_y, l, n);
//  negative(image2, dim_x, dim_y);
  return image2;  //la funzione ritorna l'array in cui  memorizzata la Black Mask
}



/******************************************************************************
* GRADIENT                                                                    *
*                                                                             *
* Gradient function does the closure on the gradient image.                   *
* A first gradient mask is applied to the image in order to obtain the        *
* horizontal gradient of the image. The a second mask is applied to obtain    *
* the vertical gradient. Horizontal and vertical gradients are then summed    *
* in the final image with the final gradient. To the resulting image is done  *
* a closure. In the gradient mask the licence plate appears uniformly white,  *
* because the characters' edge visible on the plate and on the gradient image *
* are merged after the final closure.                                         *
*                                                                             *
* *************************************************************************** *
* @param  image       input image                                             *
* @param  gradient    copy of the image where the result will be stored       *
* @param  half        support array                                           *
* @param  end_out     support array where to store the modified image         *
* @param  half_gradient support array                                      *         
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
* @param  l           width  of the dilation window                           *
* @param  n           height of the dilation window                           *
******************************************************************************/

uchar* gradientMask(uchar* image, uchar* gradient, uchar* half, uchar* end_out, int *half_gradient, int dim_x, int dim_y, int l, int n)
{
  printf("\nGradient mask");
  int i,max,min,temp1,temp2;
  int w=1;
    
  dim=dim_x*dim_y; 
  max=0;
  min=0;

  while(w<dim_y-1)  //scorro tutte le colonne dell'immagine
  {
    for(i=(dim_x*w)+1;i<(dim_x*w)+dim_x-1; i++) //scorro tutti i pixel della fotografia, riga per riga ad esclusione di
                          //quelli collocati nella prima ed ultima riga, e nella prima ed ultima colonna.
                          //si fa cos perch devo applicare la maschera gradiente 3x3 ad ogni pixel
    {
      //valore risultato dopo l'applicazione della prima maschera gradiente
      temp1=-image[i-dim_x-1]-2*image[i-1]-image[i+dim_x-1]+image[i-dim_x+1]+2*image[i+1]+image[i+1+dim_x];

      //valore risultato dopo l'applicazione della seconda maschera gradiente
      temp2=-image[i-dim_x-1]+image[i+dim_x-1]-2*image[i-dim_x]+2*image[i+dim_x]-image[i-dim_x+1]+image[i+1+dim_x];

      if(temp1<0) //se il valore  negativo lo trasformo nel suo opposto
      {
        temp1=-temp1;
      }

      if(temp2<0) //se il valore  negativo lo trasformo nel suo opposto
      {
        temp2=-temp2;
      }

      half_gradient[i]=temp1+temp2; //somma dei valori di ogni pixel calcolati con le due maschere gradiente

      if(i==0)
      {
        max=half_gradient[i]; //tengo memoria del max e min dei valori dell'array per poi fare una normalizzazione
        min=half_gradient[i];
      }

      if(half_gradient[i]>max)
      {
        max=half_gradient[i];
      }
      
      if(half_gradient[i]<min)
      {
        min=half_gradient[i];
      }

    }
    w++;  //passo alla riga successiva
  }
  
  w=1;

  while(w<dim_y-1)  //scorro tutti i pixel riga per riga, esclusa la prima e l'ultima, e li normalizzo
  {
    for(i=(dim_x*w)+1;i<(dim_x*w)+dim_x-1; i++) //tutti i pixel di una riga, escluso il primo e l'ultimo
    {
      gradient[i]=((half_gradient[i]-min)*255)/(max-min); //funzione di normalizzazione
    }
    w++;
  }
  
  for(i=0;i<dim_x;i++)  //prima riga resa nera
  {
    gradient[i]=0;
  }

  for(i=dim-1;i>dim-dim_x;i=i-1)  //ultima riga resa nera
  {
    gradient[i]=0;
  }
  
  for(i=0;i<dim;i=i+dim_x)  //prima ed ultima colonna resa nera
  {
    gradient[i]=0;
    gradient[i+dim_x-1]=0;
  }

  end_out = dilate(gradient, half, end_out, dim_x, dim_y, l, n);  //closure sull'immagine risultato
    image = erode(end_out, half, image, dim_x, dim_y, l, n);
  
  return gradient; //la funzione ritorna l'array in cui  memorizzata la Gradient Mask
}


/******************************************************************************
* CORNER MASK                                                                 *
*                                                                             *
* Corner Mask does the closure on the crossed gradient image.                 *
* As the gradient function, there is a horizontal and a vertical mask.        *
* A final closure is done on the resulting image.                             *
* This function is useful to view the corners merged in the closure.          *
*                                                                             *
* *************************************************************************** *
* @param  image       input image                                             *
* @param  corner      copy of the image where the result will be stored       *
* @param  half        support array                                           *
* @param  end_out     support array where to store the modified image         *
* @param  half_corner support array                                           *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
* @param  l           width  of the dilation window                           *
* @param  n           height of the dilation window                           *
******************************************************************************/

uchar* cornerMask(uchar* image, uchar* corner, uchar* half, uchar* end_out, int *half_corner, int dim_x, int dim_y, int l, int n)
{
  printf("\nCorner Mask");
  int i,max,min,temp1,temp2;
  int w=1;
    
  dim=dim_x*dim_y;

  max=0;  //variabile inc ui inserire il valore max incontrato per effettuare la normalizzazione
  min=0;  //variabile in cui inserire il valore min incontrato per effettuare la normalizzazione

  while(w<dim_y-1)  //scorro tutte le colonne dell'immagine
  {
    for(i=(dim_x*w)+1;i<(dim_x*w)+dim_x-1; i++) //scorro tutti i pixel della fotografia, riga per riga ad esclusione di
                          //quelli collocati nella prima ed ultima riga, e nella prima ed ultima colonna.
                          //si fa cos perch devo applicare la maschera gradiente 3x3 ad ogni pixel
    {
      //valore risultato dopo l'applicazione della prima maschera gradiente
      temp1=-image[i-dim_x-1]-2*image[i-1]-image[i+dim_x-1]+image[i-dim_x+1]+2*image[i+1]+image[i+1+dim_x];
      
      if(temp1<0) //se il valore  negativo lo trasformo nel suo opposto
      {
        temp1=-temp1;
      }

      half_corner[i]=temp1;

      if(i==0)
      {
        max=half_corner[i]; //tengo memoria del max e min dei valori dell'array per poi fare una normalizzazione
        min=half_corner[i];
      }

      if(half_corner[i]>max)  //se il valore  max rispetto a quello gi memorizzato lo salvo
      {
        max=half_corner[i];
      }
      
      if(half_corner[i]<min)
      {
        min=half_corner[i];
      }

    }
    w++;  //passo alla riga successiva
  }
  
  w=1;

  while(w<dim_y-1)  //scorro tutte le righe esclusa la prima e l'ultima
  {
    for(i=(dim_x*w)+1;i<(dim_x*w)+dim_x-1; i++) //tutti i pixel della riga, escluso il rpimo e l'ultimo
    {
      corner[i]=((half_corner[i]-min)*255)/(max-min); //funzione di normalizzazione per ogni pixel
    }
    w++;
  }
  
  for(i=0;i<dim_x;i++)  //tutti i pixel della prima riga li pongo neri
  {
    corner[i]=0;
  }

  for(i=dim-1;i>dim-dim_x;i=i-1)  //tutti i pixel dell'ultima riga li pongo neri
  {
    corner[i]=0;
  }
  
  for(i=0;i<dim;i=i+dim_x)  //tutti i pixel della prima ed ultima colonna lo pongo neri
  {
    corner[i]=128;
    corner[i+dim_x-1]=0;
  }

  w=1;
  max=0;
  min=0;

  while(w<dim_y-1)  //scorro tutti i pixel di ogni riga esclusa la prima e l'ultima
  {
    for(i=(dim_x*w)+1;i<(dim_x*w)+dim_x-1; i++) //tutti i pixel della riga esclusoil primo e l'ultimo
    {
      //valore risultato dopo l'applicazione della seconda maschera gradiente
      temp2=-corner[i-dim_x-1]+corner[i+dim_x-1]-2*corner[i-dim_x]+2*corner[i+dim_x]-corner[i-dim_x+1]+corner[i+1+dim_x];
      
      if(temp2<0) //se il valore  negativo lo trasformo nel suo opposto
      {
        temp2=-temp2;
      }

      half_corner[i]=temp2;

      if(i==0)
      {
        max=half_corner[i]; //memorizzo il max e il min di ogni valore per fare poi una normalizzazione
        min=half_corner[i];
      }

      if(half_corner[i]>max)
      {
        max=half_corner[i];
      }
      
      if(half_corner[i]<min)
      {
        min=half_corner[i];
      }

    }
    w++;  //passo alla riga successiva
  }
  
  w=1;

  while(w<dim_y-1)  //scorro tutte le righe esclusa la prima e l'ultima
  {
    for(i=(dim_x*w)+1;i<(dim_x*w)+dim_x-1; i++) //tutti i pixel di ogni riga escluso il primo e l'ultimo
    {
      corner[i]=((half_corner[i]-min)*255)/(max-min); //funzione di normalizzazione per ogni pixel
    }
    w++;
  }
  
  for(i=0;i<dim_x;i++)  //tutti i pixel della prima riga li pongo neri
  {
    corner[i]=0;
  }

  for(i=dim-1;i>dim-dim_x;i=i-1)  //tutti i pixel dell'ultima riga li pongo neri
  {
    corner[i]=0;
  }
  
  for(i=0;i<dim;i=i+dim_x)  //tutti i pixel della prima ed ultima colonna lo pongo neri
  {
    corner[i]=0;
    corner[i+dim_x-1]=0;
  }
    
  end_out = dilate(corner, half, end_out, dim_x, dim_y, l, n);  //closure dopo l'appliazione delle due maschere gradiente

    image = erode(end_out, half, image, dim_x, dim_y, l, n);
  
  return image; //la funzione ritorna l'array in cui  memorizzata la Corner Mask

}


/******************************************************************************
* STROKE MASK                                                                 *
*                                                                             *
* Stroke Mask isolates the dark and thin lines on light background.           *
* During the first step a series of dilation are applied sequentially, and    *
* followed by an erosion. The value of the window used for the dilate and     *
* erode functions (k) is a little bigger than the width of a character on the *
* licence plate.                                                              *
* On the second step is performed a k-closure, used to filter the lines with  *
* width less then or equal to k.                                              *
* The resulting image is then subtracted from the original image and in the   *
* end there is a final closure.                                               *
*                                                                             *
* *************************************************************************** *
* @param  image       input image                                             *
* @param  stroke      copy of the image where the result will be stored       *
* @param  image11     copy of the original image                              *
* @param  half        support array                                           *
* @param  end_out     support array where to store the modified image         *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
* @param  l           width  of the dilation window                           *
* @param  n           height of the dilation window                           *
******************************************************************************/

uchar* strokeMask(uchar* image, uchar* stroke, uchar* image11, uchar* half, uchar* end_out, int dim_x, int dim_y, int l, int n)
{
  printf("\nStroke Mask");
  int i,j,k,min,max;
  int count = 1;  

  l=l_kclosure; //dimensioni finestra con cui fare dilate ed erode in sequenza
  n=n_kclosure;
    
  end_out = dilate(image, half, end_out, dim_x, dim_y, l, n); //prima dilate

  k=stroke_kclosure;  //numero di dilate ed erode da fare in sequenza.

  for(j=1; j<k; j++)
  {
    if(count == 1)  //seconda dilate e altre pari
      {
      image = dilate(end_out, half, image, dim_x, dim_y, l, n);
      count = 0;
      }
    else  //terza dilate e altre dispari
      {
      end_out = dilate(image, half, end_out, dim_x, dim_y, l, n); 
      count = 1;
      }
  }

  if (count == 1) //dopo aver fatto un numero di dilate dispari faccio la prima erode
    image = erode(end_out, half, image, dim_x, dim_y, l, n);
  
  else  //dopo aver fatto un numero di dilate pari faccio la prima erode 
    end_out = erode(image, half, end_out, dim_x, dim_y, l, n);  
  
  
  for(j=1; j<k; j++)
  {
    if (count == 1) //seconda erode e altre pari
    {
      end_out = erode(image, half, end_out, dim_x, dim_y, l, n);
          count = 0;
    } 
    else  //terza erode e altre dispari
    {
        image = erode(end_out, half, image, dim_x, dim_y, l, n);
      count = 1;
    }
  }
  
  dim=dim_x*dim_y;

  if (count == 1) //se ho fatto erode disperi il risultato  in end_out e cos lo copio in image, altrimenti
          //con erode pari il risultato  gi in image
      end_out=image; 

    int half_stroke[800*600];    
//  half_stroke=(int*)malloc(sizeof(int)*dim_x*dim_y);  //array in cui memorizzo il risultato di (k closure - originale)
  

  min=0;
  max=0;

  for(i=0;i<dim;i++)
  {
    half_stroke[i]= end_out[i] - stroke[i];  //k closure - originale
    
    if(half_stroke[i]<0)  //se il valore  negativo lo pongo a 0 e quindi nero
      half_stroke[i]=0;

    stroke[i]=half_stroke[i];
    image11[i]=(255-half_stroke[i]);
  }

  l=l_strokeclosure;  //dimensioni finestra con cui applicare una closure finale
  n=n_strokeclosure;
    
  image = dilate(stroke , half, image, dim_x, dim_y, l, n); //closure finale
  stroke = erode(image , half, stroke, dim_x, dim_y, l, n);
    
  return stroke;  //la funzione ritorna l'array in cui  memorizzata la Stroke Mask
}




/******************************************************************************
* MERGING MASK                                                                *
*                                                                             *
* Merging Mask performs the merging between all the masks.                    *
* Each pixel has a value that corresponds to the median value among the       *
* five analyzed masks (white, black, gradient, corner, stroke).               *
*                                                                             *
* *************************************************************************** *
* @param  image       input image                                             *
* @param  white       array of the white mask                                 *
* @param  black       array of the black mask                                 *
* @param  gradient    array of the gradient mask                              *
* @param  corner      array of the corner mask                                *
* @param  stroke      array of the stroke mask                                *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
******************************************************************************/

uchar* mergingMask(uchar* image,uchar* selection, uchar* white, uchar* black, uchar* gradient, uchar* corner, uchar* stroke, int dim_x, int dim_y)
{
  
  printf("\nMerging Mask");
  int i,j,z,t,k,mem,n;
  int v[5];
  int valor_medio;
  
  dim = dim_x * dim_y;

  //-------------------------------------------------------------
  //algoritmo per il calcolo della mediana
  for(k=0;k<contatore;k++)
  {
    valor_medio=0;
    for (i=targa[k].up;i<=targa[k].down; i++)
      for(j=targa[k].sx;j<=targa[k].dx; j++)
    {  
       v[0] = white[DIM_X*i+j];
       v[1] = black[DIM_X*i+j];
       v[2] = gradient[DIM_X*i+j];
       v[3] = corner[DIM_X*i+j];
       v[4] = stroke[DIM_X*i+j];

       n=5;
    
    for(z=0;z<n;z++)
    {
      for(t=0;t<n -1 ;t++)
      {
        if(v[t]>v[t+1])
        {
          mem=v[t];
          v[t]=v[t+1];
          v[t+1]=mem;
        }
      }
      n=n-1;
    }
    image[DIM_X*i+j] = v[2];  //valore mediano
    
//    valor_medio= v[2]+valor_medio;
//    image[DIM_X*i+j] = ((v[0]+v[1]+v[2]+v[3]+v[4])/n)*selection[DIM_X*i+j];  //valore medio    
    }

//    targa[k].val=valor_medio/((targa[k].down-targa[k].up)*(targa[k].dx-targa[k].sx));

  }
  //fine calcolo mediana
  //--------------------------------------------------------------------------
//  print_merge(image);
  
  return image; //la funzione ritorna l'array in cui  memorizzata la Merging Mask
}



/******************************************************************************
* FINAL MASK                                                                  *
*                                                                             *
* Final Mask performs a closure of the same dimention as a licence plate on   *
* the image resulting from the merging mask.                                  *
*                                                                             *
* *************************************************************************** *
* @param  final       input image                                             *
* @param  merging     array of the merging mask                               *
* @param  half        support array                                           *
* @param  end_out     support array where to store the modified image         *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
* @param  l           width  of the dilation window                           *
* @param  n           height of the dilation window                           *
******************************************************************************/

uchar* finalMask(uchar* final, uchar* merging, uchar* half, uchar* end_out, int dim_x, int dim_y, int l, int n)
{
  printf("\nFinal mask");
  l = l_finalclosure;   //larghezza finestra
  n = n_finalclosure;   //altezza finestra

  end_out = dilate(merging, half, end_out, dim_x, dim_y, l, n); //closure
  final = erode(end_out, half, final, dim_x, dim_y, l, n);

  return final; //la funzione ritorna l'array in cui  memorizzata la Final Mask
}



/******************************************************************************
* BINARIZED MASK                                                              *
*                                                                             *
* Binarized Mask is a two colors image. Each pixel's value can be either      *
* black or white (0 or 255). The area will be white where the final mask      *
* pixels' value will be more than a certain threshold. In those areas is more *
* probable to find a plate.                                                   *
*                                                                             *
* *************************************************************************** *
* @param  final       array of the final mask                                 *
* @param  binarized   copy of the image where the result will be stored       *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
******************************************************************************/

uchar* binarizedMask(uchar* final, uchar* binarized, int dim_x, int dim_y)
{
  printf("\nBinarized mask");
  int i;
  int soglia;

  soglia=soglia_final;  //soglia sopra la quale rendere i valori della final mask a 255, cio bianchi, gli altri a 0, cio neri

  dim = dim_x * dim_y;

  for (i = 0; i < dim; i++)
  {
    if (final[i] >= soglia)
    {
      binarized[i] = 255;
    }
    else 
    { 
      binarized[i] = 0;
    }
  }

  return binarized; //la funzione ritorna l'array in cui  memorizzata la Binarized Mask
}



/******************************************************************************
* THRESHOLDING MASK                                                           *
*                                                                             *
* Thresholding Mask is obtained multiplying the binarized mask and a copy     *
* image of the k-closure of the stroke mask. In practice in the white windows *
* of the binarized mask there will be the image of the k-closure.             *
* The final result is a black mask with windows of the modified k-closure.    *
*                                                                             *
* *************************************************************************** *
* @param  binarized   array of the binarized image                            *
* @param  image11     copy of the k-closure image of the stroke mask          *
* @param  thresholding  array of the thresholding mask                        *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
******************************************************************************/

uchar* thresholdingMask(uchar* binarized, uchar* image11, uchar* thresholding, int dim_x, int dim_y)
{
  printf("\nThresholding mask");
  int i;

  dim = dim_x * dim_y;

  for(i=0; i<dim; i++)
    {
      if(binarized[i]==255)
        binarized[i]=1;
    }

  for(i=0; i<dim; i++)
    {
      thresholding[i] = (binarized[i] * image11[i]);  //binarized * immagine originale, in modo da vedere solo la parte dentro le finestre bianche della binarized
    }

  for (i=0; i<dim; i++)
  {
    if (thresholding[i] >= 243)  //per dare pi nitidezza
    {
      thresholding[i] = 255;
    }
    else 
    { 
      thresholding[i] = 0;
    }
  }

  return thresholding;
}


/******************************************************************************
* FLOOD FILL MASK                                                             *
*                                                                             *
* Flood Fill Mask is a function that applies the 4-way and 8-way flood fill   *
* algorithm to a binary image (only b/w).                                     *
*                                                                             *
* *************************************************************************** *
* @param  thresholding  array of the thresholding mask                        *
******************************************************************************/
void floodFillMask(uchar *image)
{
 printf("\nFloodFill");
 int cont;                           //contatore del numero di pixel bianchi da considerare
 int index;
 PIXEL blob[1024];                      //array contente i blob trovati
 ELEM list[1024];                       //array di elementi da far scorrere
 int visto[DIM_X][DIM_Y];               //metto a 1 se  stato visitato, 0 altrimenti
 int i,j,x,y,z;
 int sx,dx,up,dw;
 int incr;
 int n;
 int segue_dx,segue_sx;
 
 z=0;
 for(i=0;i<DIM_Y;i++)                             //binarizzo
   for(j=0;j<DIM_X;j++){
    if(image[DIM_X*i+j]>127)
      image[DIM_X*i+j]=255;
    else
      image[DIM_X*i+j]=0;
 }
 
 for(i=0;i<DIM_Y;i++)                              //metto a 0 il vettore dei visti
   for(j=0;j<DIM_X;j++)
     visto[j][i]=0;
 
  for(i=0;i<DIM_Y;i++)
   for(j=0;j<DIM_X;j++){                           //ciclo sull'immagine in cerca di un pixel bianco non visto
     index=0;
     cont=0;
     if(image[DIM_X*i+j]==255&&visto[j][i]==0)
     {    //TROVA IL PIXEL DAL QUALE PARTIRE
       list[index].x=j;
       list[index].y=i;
       sx=j;
       dx=j;
       up=i;
       dw=i; 
       index++;
       n=0;    
       while(index!=n){
         //giro sotto
         incr=0;
         x=list[n].x;
         y=list[n].y;
         //devo ciclare finch trovo pixel bianchi in verticale        
         segue_dx=0;
         segue_sx=0;
         while(image[DIM_X*(y+incr)+x]==255 && visto[x][y+incr]==0){
         visto[x][y+incr]=1;
         cont++;
         //guardo a destra
           if(x+1<=DIM_X)
           if(image[DIM_X*(y+incr)+x+1]==255&&visto[x+1][y+incr]==0){
           //controllo il pixel pi a sx,dx,alto e basso
             if(x+1<sx)
               sx=x+1;
             if(x+1>dx)
               dx=x+1;
             if(y+incr<up)
               up=y+incr;
             if(y+incr>dw)
               dw=y+incr;
             //se il flag continua  attivo non lo inserisco, se non  attivo inserisco il pixel in lista
             if(segue_dx==0){
               list[index].x=x+1;
               list[index].y=y+incr;
               index++;
               segue_dx=1;
             }  
           }
           else
             segue_dx=0;
         //guardo a sinistra
           if(x-1>=0)
           if(image[DIM_X*(y+incr)+x-1]==255 && visto[x-1][y+incr]==0){
             //controllo il pixel pi a sx,dx,alto e basso
             if(x-1<sx)
               sx=x-1;
             if(x-1>dx)
               dx=x-1;
             if(y+incr<up)
               up=y+incr;
             if(y+incr>dw)
               dw=y+incr;
             //se il flag continua  attivo non lo inserisco, se non  attivo inserisco il pixel in lista
             if(segue_sx==0){
               list[index].x=x-1;
               list[index].y=y+incr;
               index++;
               segue_sx=1;
             }  
           }
           else
             segue_sx=0;  
           incr++;     
           if(y+incr>DIM_Y)
             break;
         }
         
         //giro sotto
        incr=0;
         visto[x][y]=0;
         cont--;
         //devo ciclare finch trovo pixel bianchi in verticale        
         segue_dx=0;
         segue_sx=0;
         while(image[DIM_X*(y-incr)+x]==255 && visto[x][y-incr]==0){
         visto[x][y-incr]=1;
         cont++;
         //guardo a destra
           if(x+1<=DIM_X)
           if(image[DIM_X*(y-incr)+x+1]==255&&visto[x+1][y-incr]==0){
           //controllo il pixel pi a sx,dx,alto e basso
             if(x+1<sx)
               sx=x+1;
             if(x+1>dx)
               dx=x+1;
             if(y-incr<up)
               up=y-incr;
             if(y-incr>dw)
               dw=y-incr;
             //se il flag continua  attivo non lo inserisco, se non  attivo inserisco il pixel in lista
             if(segue_dx==0){
               list[index].x=x+1;
               list[index].y=y-incr;
               index++;
               segue_dx=1;
             }  
           }
           else
             segue_dx=0;
         //guardo a sinistra
           if(x-1>=0)
           if(image[DIM_X*(y-incr)+x-1]==255 && visto[x-1][y-incr]==0){
             //controllo il pixel pi a sx,dx,alto e basso
             if(x-1<sx)
               sx=x-1;
             if(x-1>dx)
               dx=x-1;
             if(y-incr<up)
               up=y-incr;
             if(y-incr>dw)
               dw=y-incr;
             //se il flag continua  attivo non lo inserisco, se non  attivo inserisco il pixel in lista
             if(segue_sx==0){
               list[index].x=x-1;
               list[index].y=y-incr;
               index++;
               segue_sx=1;
             }  
           }
           else
             segue_sx=0;  
           incr++;     
           if(y-incr<0)
             break;
         }
       
         n++;
       
       }
       blob[z].up=up;
       blob[z].down=dw;
       blob[z].sx=sx;
       blob[z].dx=dx;
       blob[z].count=cont;
       z++;
     }   
   } 
for(i=0;i<z;i++)
printf("\nsx: %d\ndx: %d\nup: %d\ndw: %d\ncont: %d",blob[i].sx,blob[i].dx,blob[i].up,blob[i].down,blob[i].count);  
 
}




/******************************************************************************
* CLOSURE BINARIZED MASK                                                      *
*                                                                             *
* Closure Binarized Mask applies a closure to a binarized image (only b/w).   *
*                                                                             *
* *************************************************************************** *
* @param  thresholding              array of the thresholding mask            *
* @param  closure_binarized_dilate  array where to store the result after the *
*                                   dilation function                         *
* @param  closure_binarized         array where to store the result after the *
*                                   erosion function and total closure        *
* @param  dim_x       width  of the image to be equalized                     *
* @param  dim_y       height of the image to be equalized                     *
******************************************************************************/

uchar* closure_binarizedMask(uchar* thresholding, uchar* closure_binarized_dilate, uchar* closure_binarized, int dim_x, int dim_y)
{
  printf("\nClosure binarized mask");
  int i,j;
  int w=1;

  dim=dim_x*dim_y;

  for (i=0;i<dim;i++) //utilizzo come base su cui lavorare la thresholding
  {
    closure_binarized_dilate[i]=thresholding[i];
  }

  for(j=0;j<dim;j=j+dim_x)  //prima colonna
    {
      if(j==0)  //primo pixel
      {
        if(thresholding[j+1]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j+1+dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j+dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }
      }
      
      else if(j==dim-dim_x) //ultimo pixel
      {
        if(thresholding[j-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j+1-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j+1]==255)
        {
          closure_binarized_dilate[j]=255;
        }
      }

      else 
      {
        if(thresholding[j-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j+1-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j+1]==255)
        {
          closure_binarized_dilate[j]=255;
        }
        
        else if(thresholding[j+1+dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }
        
        else if(thresholding[j+dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }
      }
    }
  
  for(j=dim_x-1;j<dim;j=j+dim_x)  //ultima colonna
    {
      if(j==dim_x-1)  //primo pixel
      {
        if(thresholding[j-1]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j-1+dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j+dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }
      }
      
      else if(j==dim-1) //ultimo pixel
      {
        if(thresholding[j-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j-1-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j-1]==255)
        {
          closure_binarized_dilate[j]=255;
        }
      }

      else 
      {
        if(thresholding[j-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j-1-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }

        else if(thresholding[j-1]==255)
        {
          closure_binarized_dilate[j]=255;
        }
        
        else if(thresholding[j-1+dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }
        
        else if(thresholding[j-dim_x]==255)
        {
          closure_binarized_dilate[j]=255;
        }
      }
    }
  
  for(j=1;j<dim_x-1;j=j+1)  //prima riga
    {
      if(thresholding[j-1]==255)
      {
        closure_binarized_dilate[j]=255;
      }

      else if(thresholding[j-1+dim_x]==255)
      {
        closure_binarized_dilate[j]=255;
      }

      else if(thresholding[j+dim_x]==255)
      {
        closure_binarized_dilate[j]=255;
      }
    
      else if(thresholding[j+dim_x+1]==255)
      {
        closure_binarized_dilate[j]=255;
      }
      
      else if(thresholding[j+1]==255)
        {
          closure_binarized_dilate[j]=255;
        }
    }
        
  for(j=dim-dim_x+1;j<dim-1;j=j+1)  //ultima riga
    {
      if(thresholding[j-1]==255)
      {
        closure_binarized_dilate[j]=255;
      }

      else if(thresholding[j-1-dim_x]==255)
      {
        closure_binarized_dilate[j]=255;
      }

      else if(thresholding[j-dim_x]==255)
      {
        closure_binarized_dilate[j]=255;
      }
    
      else if(thresholding[j-dim_x+1]==255)
      {
        closure_binarized_dilate[j]=255;
      }
      
      else if(thresholding[j+1]==255)
        {
          closure_binarized_dilate[j]=255;
        }
    }

  while(w<dim_y-1)  //resto dell'immagine escluso prima ed ultima riga e colonna
  {
    for(j=(dim_x*w)+1;j<(dim_x*w)+dim_x-1;j++)
    {
      if(thresholding[j-1]==255)
      {
        closure_binarized_dilate[j]=255;
      }

      else if(thresholding[j-1+dim_x]==255)
      {
        closure_binarized_dilate[j]=255;
      }

      else if(thresholding[j+dim_x]==255)
      {
        closure_binarized_dilate[j]=255;
      }
    
      else if(thresholding[j+dim_x+1]==255)
      {
        closure_binarized_dilate[j]=255;
      }
      
      else if(thresholding[j+1]==255)
        {
          closure_binarized_dilate[j]=255;
        }
      
      else if(thresholding[j-dim_x+1]==255)
      {
        closure_binarized_dilate[j]=255;
      }
      
      else if(thresholding[j-dim_x]==255)
      {
        closure_binarized_dilate[j]=255;
      }
      
      else if(thresholding[j-1-dim_x]==255)
      {
        closure_binarized_dilate[j]=255;
      }

    }
    w++;
  }
  
  //-------------------------------------------------------------------------
  //inizio erosion

  for (i=0;i<dim;i++)
  {
    closure_binarized[i]=closure_binarized_dilate[i];
  }

  for(j=0;j<dim;j=j+dim_x)  //prima colonna
    {
      if(j==0)
      {
        if(closure_binarized_dilate[j+1]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j+1+dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j+dim_x]==0)
        {
          closure_binarized[j]=0;
        }
      }
      
      else if(j==dim-dim_x)
      {
        if(closure_binarized_dilate[j-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j+1-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j+1]==0)
        {
          closure_binarized[j]=0;
        }
      }

      else 
      {
        if(closure_binarized_dilate[j-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j+1-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j+1]==0)
        {
          closure_binarized[j]=0;
        }
        
        else if(closure_binarized_dilate[j+1+dim_x]==0)
        {
          closure_binarized[j]=0;
        }
        
        else if(closure_binarized_dilate[j+dim_x]==0)
        {
          closure_binarized[j]=0;
        }

      }
    }
  
  for(j=dim_x-1;j<dim;j=j+dim_x)  //ultima colonna
    {
      if(j==dim_x-1)
      {
        if(closure_binarized_dilate[j-1]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j-1+dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j+dim_x]==0)
        {
          closure_binarized[j]=0;
        }
      }
      
      else if(j==dim-1)
      {
        if(closure_binarized_dilate[j-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j-1-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j-1]==0)
        {
          closure_binarized[j]=0;
        }
      }

      else 
      {
        if(closure_binarized_dilate[j-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j-1-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

        else if(closure_binarized_dilate[j-1]==0)
        {
          closure_binarized[j]=0;
        }
        
        else if(closure_binarized_dilate[j-1+dim_x]==0)
        {
          closure_binarized[j]=0;
        }
        
        else if(closure_binarized_dilate[j-dim_x]==0)
        {
          closure_binarized[j]=0;
        }

      }
    }
  
  for(j=1;j<dim_x-1;j=j+1)  //prima riga
    {
      if(closure_binarized_dilate[j-1]==0)
      {
        closure_binarized[j]=0;
      }

      else if(closure_binarized_dilate[j-1+dim_x]==0)
      {
        closure_binarized[j]=0;
      }

      else if(closure_binarized_dilate[j+dim_x]==0)
      {
        closure_binarized[j]=0;
      }
    
      else if(closure_binarized_dilate[j+dim_x+1]==0)
      {
        closure_binarized[j]=0;
      }
      
      else if(closure_binarized_dilate[j+1]==0)
        {
          closure_binarized[j]=0;
        }
    }
        
  for(j=dim-dim_x+1;j<dim-1;j=j+1)  //ultima riga
    {
      if(closure_binarized_dilate[j-1]==0)
      {
        closure_binarized[j]=0;
      }

      else if(closure_binarized_dilate[j-1-dim_x]==0)
      {
        closure_binarized[j]=0;
      }

      else if(closure_binarized_dilate[j-dim_x]==0)
      {
        closure_binarized[j]=0;
      }
    
      else if(closure_binarized_dilate[j-dim_x+1]==0)
      {
        closure_binarized[j]=0;
      }
      
      else if(closure_binarized_dilate[j+1]==0)
        {
          closure_binarized[j]=0;
        }
    }

  w=1;
  while(w<dim_y-1)
  {
    for(j=(dim_x*w)+1;j<(dim_x*w)+dim_x-1;j++)
    {
      if(closure_binarized_dilate[j-1]==0)
      {
        closure_binarized[j]=0;
      }

      else if(closure_binarized_dilate[j-1+dim_x]==0)
      {
        closure_binarized[j]=0;
      }

      else if(closure_binarized_dilate[j+dim_x]==0)
      {
        closure_binarized[j]=0;
      }
    
      else if(closure_binarized_dilate[j+dim_x+1]==0)
      {
        closure_binarized[j]=0;
      }
      
      else if(closure_binarized_dilate[j+1]==0)
        {
          closure_binarized[j]=0;
        }
      
      else if(closure_binarized_dilate[j-dim_x+1]==0)
      {
        closure_binarized[j]=0;
      }
      
      else if(closure_binarized_dilate[j-dim_x]==0)
      {
        closure_binarized[j]=0;
      }
      
      else if(closure_binarized_dilate[j-1-dim_x]==0)
      {
        closure_binarized[j]=0;
      }

    }
    w++;
  }

  return closure_binarized;
}


uchar* print_blob(uchar* image, uchar* temp,int x1,int x2,int y1,int y2){
  int i,j;
  int y=0;

    for(i=y1;i<=y2;i++)
      for(j=x1;j<=x2;j++)
        temp[DIM_X*(i+y-y1)+j-x1]=image[DIM_X*i+j];
  
  return temp;
}




////////////////parte spagnola ///////////////////////////////

/*
  Funzione ausiliare
*/
int mul(float decx,float decy,int x, int y, unsigned char* img,int k){ 
	int i=DIM_X-1;    return decx*decy*img[m(x,y,k)];    
}

/*
  Restituisce il num-essimo valore dell'array 'array' con size 'tamarray'
  num:        posizione desiderata
  tamarray:   size dell'array
  array:      Array del quale si vuole prendere un valore
*/
int obtener(int num, int tamarray,int array[]){
    if(num<0) return array[0];
    if(num>tamarray-1) return array[tamarray-1];
    return array[num];
}

/*
  Fa una media mobile da 'media' in 'media' dil array 'suma' e lo restituisce in 'suma2'
  media:       Prende i 'media' valori per fare la media
  tamsuma:     Size degli array
  suma:        Array origine
  suma2:       Array dove si restituisce la media
*/
void media(int media,int tamsuma,int suma[],int suma2[]){
     int i,j,aux;
     for(i=0;i<tamsuma;i++){
        suma2[i]=0;
        aux=-media/2;
        for(j=0;j<media;j++){
            suma2[i]+=obtener(i+aux,tamsuma,suma);
            aux++;
        }
        suma2[i]=suma2[i]/media;
     }
}

/*
  Restituisce la posizione del pixel con 'i' Height, 'j' Width y 'k' Channel
  Se esce dei limiti, restituisce il pixel del limite.
  Se se vuole fare in OpenCV si deve scomentare una riga di sotto e comentare un'altra
  i: Height
  j: Width
  k: Channel
*/
int m(int i,int j, int k){
    int i2,j2,k2;
    i2=i;j2=j;k2=k;
    if(i<0)               {i2=0;
    }else if(i>=DIM_Y)   {i2=DIM_Y-1;
    }else if(j<0)         {j2=0;
    }else if(j>=DIM_X)    {j2=DIM_X-1;
    }else if(k<0)         {k2=0;
    }else if(k>=CHANNELS) {k2=CHANNELS-1;}
    
    return i2*DIM_X+j2;                   // Per la telecamera
    // return i2*STEP+j2*CHANNELS+k2;     // Modo OpenCV (RGB)
}

/*
  Restituisce in Dest l'immagine img con l'homography fatta secondo la matrice 3x3 invT con
  il metodo nearest neightbour
  img:      immagine origine
  dest:     immagine destino
  invT:     Matrice H della homography
*/
void homography(unsigned char* img, unsigned char* dest, float invT[3][3]){
    int i,j,k,cont;
    int xy[2];
    float aux[3];
    
    for(i=0;i<DIM_Y;i++) for(j=0;j<DIM_X;j++) for(k=0;k<CHANNELS;k++){                          
        for(cont=0;cont<3;cont++){
             aux[cont]=(float)i*invT[cont][0]+(float)j*invT[cont][1]+invT[cont][2];
        }
        xy[0]=(int)(aux[0]/aux[2]);
        xy[1]=(int)(aux[1]/aux[2]);
        if(xy[0]<0||xy[0]>DIM_Y||xy[1]<0||xy[1]>DIM_X){
             dest[m(i,j,k)]=0;
        }else{  
             dest[m(i,j,k)]=img[m(xy[0],xy[1],k)];
        }                   
    }
}

/*
  Restituisce in Dest l'immagine img con l'homography fatta secondo la matrice 3x3 invT con
  il metodo interpolation
  img:      immagine origine
  dest:     immagine destino
  invT:     Matrice H della homography
*/
void interpolation(unsigned char* img, unsigned char* dest, float invT[3][3]){
    int i,j,k,cont;
    float decx, decy;
    float xy[2];
    float aux[3];
    
    for(i=0;i<DIM_Y;i++) for(j=0;j<DIM_X;j++) for(k=0;k<CHANNELS;k++){                          
        for(cont=0;cont<3;cont++){
             aux[cont]=(float)i*invT[cont][0]+(float)j*invT[cont][1]+invT[cont][2];                          
        }
        xy[0]=aux[0]/aux[2];
        xy[1]=aux[1]/aux[2];
        if((xy[0]<0||xy[0]>DIM_Y||xy[1]<0||xy[1]>DIM_X)){
             dest[m(i,j,k)]=0;
        }else{
             decx=((int)((xy[0]-(int)xy[0])*10)%10)/10.0f;
             decy=((int)((xy[1]-(int)xy[1])*10)%10)/10.0f;
             
             dest[m(i,j,k)]=mul(1-decx,1-decy,xy[0],  xy[1],  img,k)+
                            mul(  decx,1-decy,xy[0]+1,xy[1],  img,k)+
                            mul(1-decx,  decy,xy[0],  xy[1]+1,img,k)+
                            mul(  decx,  decy,xy[0]+1,xy[1]+1,img,k);                                   
            
            }                   
    }
}

/*
  Disegna una riga verticale dal punto 'desde' fino 'hasta' nella posizione 'col'
  img:    img origine
  col:    posizione della riga verticale che si vuole disegnare
  desde:  posizione orizontale d'inizio dove si vuole disegnare la riga verticale
  hasta:  posizione orizontale finale dove si vuole disegnare la riga verticale
*/
void dibuja_col(unsigned char* img, int col, int desde, int hasta){
     int i,k;
     int inicio,fin;
     if(desde<hasta){
                     inicio=desde;fin=hasta;
     }else{          inicio=hasta;fin=desde;}
     for(i=inicio;i<fin;i++)for(k=0;k<CHANNELS;k++)img[m(i,col,k)]=255;
}
/*
  Disegna una riga orizontale dal punto 'desde' fino 'hasta' nella posizione 'fil'
  img:    img origine
  fil:    posizione della riga orizontale che si vuole disegnare
  desde:  posizione verticale d'inizio dove si vuole disegnare la riga orizontale
  hasta:  posizione verticale finale dove si vuole disegnare la riga orizontale
*/
void dibuja_fil(unsigned char* img,int fil,int desde,int hasta){
     int i,k;
     int inicio,fin;
     if(desde<hasta){
                     inicio=desde;fin=hasta;
     }else{          inicio=hasta;fin=desde;}
     for(i=inicio;i<fin;i++)for(k=0;k<CHANNELS;k++)img[m(fil,i,k)]=255;
}
/*
  Restituisce in 'suma', per ogni posizione 'i', la somma della riga verticale numero 'i'
  img:        immagine origine
  suma:       array dove si restituisce la somma dei rige verticali della immagine
  desde:      posizione verticale d'inizio
  hasta:      posizione verticale finale
*/
void sumaCol(unsigned char* img,int suma[DIM_X],int desde,int hasta){
    int i,j,k,cont;
    for(i=0;i<DIM_X;i++) suma[i]=0;
    for(i=desde;i<hasta;i++){
        for(j=0;j<DIM_X;j++) for(k=0;k<CHANNELS;k++){
            suma[j]+=(int)img[m(i,j,k)];
        }    
    }
}
/*
  Restituisce in 'suma', per ogni posizione 'i', la somma della riga orizontale numero 'i'
  img:        immagine origine
  suma:       array dove si restituisce la somma dei rige orizontali della immagine
  desde:      posizione orizontale d'inizio
  hasta:      posizione orizontale finale
*/
void sumaFil(unsigned char* img,int suma[DIM_Y]){
    int i,j,k,cont;
    for(i=0;i<DIM_Y;i++) suma[i]=0;
    for(i=0;i<DIM_Y;i++){
        for(j=0;j<DIM_X;j++) for(k=0;k<CHANNELS;k++){
            suma[i]+=(int)img[m(i,j,k)];
        }    
    }
}

/*
  ordina l'array 'maximos', secondo il contenuto di 'somma'   (suma[maximos[i]])
  suma:          array con i sommi
  maximos:       array dove si restituisce i massimi valori di 'suma' ordinati
  length:        size dell'array 'maximos'
*/
void ordenar(int suma[],int maximos[],int length){
     int i,j,aux;
     int menor=0;
     for(i=0;i<length;i++){
                           for(j=i;j<length;j++){
                                    if(suma[maximos[menor]]>suma[maximos[j]]){
                                                            menor=j;
                                    }             
                           }
                           aux=maximos[i];
                           maximos[i]=maximos[menor];
                           
                           maximos[menor]=aux;
                           menor=i+1;                           
     }
}

/*
  funzione ausiliare della funzione 'hay_sitio', restituisce la posizione dove sta il numero 'num' nell'array 'maximos'
  se non lo trova restituisce -1
  maximos:  array dove si cerca il numero 'num'
  length:   size dell'array 'maximos'
  num:      numero a trovare
*/
int esta(int maximos[],int length,int num){
    int i;
    if(num<0) num =0;
    for(i=0;i<length;i++){
                          if(maximos[i]==num) return i;
    }
    return -1;
}
/*
  Restituisce 1 se el numero 'numero'  un massimo del array 'suma' di grandeza 'tamsum', 
  se non  un massimo restituisce -1
  suma:    array inserito
  tamsum:  size dell'array
  numero:  numero dil quale si vuole sapere se  un massimo
*/
int es_max(int suma[],int tamsum,int numero){
    if(numero==0){
                 if(suma[numero+1]<suma[numero])return -1;
    }
    if(numero==tamsum-1){
                         if(suma[numero-1]<suma[numero])return -1;
    }
    if(suma[numero-1]<suma[numero] || suma[numero+1]<suma[numero]){
                                   return 1;
    }
    return -1;
}
/*
  Funzione ausiliare della funzione 'n_max',
  restituisce la posizione dove si pu inserire il numero 'numero' nell'array 'maximos', che  ordinato
  secondo il contenuto di 'suma'. Se non si pu inserire, restituisce -1.
  maximos:   Array dove si vuole inserire il numero
  suma:      'Maximos'  ordinato secondo questo contenito
  tamsum:    size di 'suma'
  length:    size di 'maximos'
  numero:    numero che si vuole inserire
*/
int hay_sitio(int suma[],int tamsum,int numero,int maximos[],int length){
    int i,j,k;
    int pos;
    if(es_max(suma,tamsum,numero)==-1)return -1;
    for(i=1;i<5;i++){
        pos=esta(maximos,length,numero-i);
        if(pos!=-1){
             if(suma[maximos[pos]]>suma[numero]){
                   return -1;
             }else{
                   maximos[pos]=numero;
                   return pos;
             }
        }
    }
    for(i=0;i<length;i++){
                          if(maximos[i]==-1 || suma[numero]>suma[maximos[i]]){
                               return i;
                          }
    }
    return -1;
}

/*
  Restituisce in 'maximos', los 'n' massimi numeri ordinati secondo il contenuto di 'suma'
  suma:       array di dove su vole prendere i massimi
  tamsum:     size di 'suma'
  maximos:    dove si vuole restituire i massimi
  n:          numero di massimi che si vuole prendere
*/
void n_max(int suma[],int tamsum,int maximos[],int n){
     int i,j,sitio;
     for(i=0;i<n;i++)maximos[i]=-1;
     for(j=0;j<tamsum;j++){
                          sitio=hay_sitio(suma,tamsum,j,maximos,n);
                          if(sitio!=-1){
                                        maximos[sitio]=j;
                                        ordenar(suma,maximos,n);
                          }
     }
                                                          
}

/*
  Funzione che s'applica ai numeri dei gradente
  num:     pixel al qual si vuole applicare una funzione
*/
int funcion(int num){
    /* cuadrado */
    int res=num*num;
    if(res>255) res = 255;
    return res;
}

/*
  Fa il gradente orizontale all'immagine 'img' e lo restituisce in 'dest'
  img:  immagine origine
  dest: immagine destino
*/
void gradiente_horizontal(unsigned char* img, unsigned char* dest){
    int i,j,k,aux;
    
    for(i=0;i<DIM_Y;i++) for(j=0;j<DIM_X;j++) for(k=0;k<CHANNELS;k++){
       aux=abs(img[m(i,j,k)]-img[m(i,j+1,k)]);
          dest[m(i,j,k)]=funcion(aux);
    } 
}
/*
  Disegna un rettangolo con le quatro rige, due verticali (vert1 e vert2) e due orizontali (hor1 e hor2), canal
  e il canale RGB dove si vuole disegnare il rettangolo
  img:        immagine dove si vuole disegnare il rettangolo
  vert1:      riga verticale 1
  vert2:      riga verticale 2
  hor1:       riga orizontale 1
  hor2:       riga orizontale 2
  canal:      canal dove si vuole disegnare (RGB)
*/
void dibujar_cuadrado(unsigned char*img,int vert1,int vert2,int hor1,int hor2,int canal){
 int i,j;
 int inic1,inic2,fin1,fin2;
 if(vert1>vert2){
     inic1=vert2;
     fin1=vert1;
 }else{
       inic1=vert1;
       fin1=vert2;
 }
 if(hor1>hor2){
       inic2=hor2;
       fin2=hor1;
 }else{inic2=hor1;fin2=hor2;}
 
     for(i=inic1;i<fin1;i++){
           for(j=inic2;j<fin2;j++){
               img[m(i,j,canal)]=255;
           }
     }
 
}
/*
  Restituisce il colore mezzo del rettangolo dato per i quatro rige che lo delimitano (col1,col2,fil1 e fil2)
  img:        immagine origine
  col1:       riga verticale 1
  col2:       riga verticale 2
  fil1:       riga orizontale 1
  fil2:       riga orizontale 2
*/
int color_medio(unsigned char* img,int col1,int col2,int fil1,int fil2){
     int i,j,k,l,res;
     int inic1,inic2,fin1,fin2;
     if(col1>col2){
           inic1=col2;
           fin1=col1;
     }else{
           inic1=col1;
           fin1=col2;
     }
     if(fil1>fil2){
           inic2=fil2;
           fin2=fil1;
     }else{
           inic2=fil1;
           fin2=fil2;
     }
      res=0;
      for(k=0;k<CHANNELS;k++)
      for(j=inic1;j<fin1;j++){
           for(i=inic2;i<fin2;i++){
               res+=img[m(i,j,k)];
           }
     }     
     res=res/(abs(inic1-fin1)*abs(inic2-fin2)*3);
     return res;
}

/*
  Prende la immagine img e restituisce in dest la stessa immagine con le possibili targhe
  
  img:           immagine origine
  dest:          immagine destino (dove sono disegnati le possibili targhe)
  num_max:       size del array maximos2
  maximos2:      Array con i 'num_max' massimi rige verticali 
  num_max_filas: size dell'array 'maximos_filas'
  maximos_filas: Array con i 'num_max_filas' massimi rige orizontali
  imH:           Immagine con il Gradiente Verticale
*/
void max_columnas(uchar *image,unsigned char*black,unsigned char*img,unsigned char*dest,int num_max,int maximos2[],int num_max_filas,int maximos_filas[],unsigned char* imH){
     
     int i,j,k,l,inicio,fin,iter;
     int suma[DIM_X];
     int suma2[DIM_X];
     int maximos[31];//num_max
     int cont1,cont2,i2;
     int contador=0;
     int linea1,linea2,col1,col2;
     int color=0;
     int coloraux=0;
     int canal=0;
     int fini,ffin,d;    
     for(i=0;i<num_max;i++)maximos2[i]=-1; // Inizializza l'array 'maximos2' a -1
     for(i=0;i<num_max_filas;i++){
         for(j=i;j<num_max_filas;j++){           
             if((abs(maximos_filas[i]-maximos_filas[j])<(HTARGA+APRXV+maximos_filas[i]*5/100)) && (abs(maximos_filas[i]-maximos_filas[j])>(HTARGA+maximos_filas[i]/100/*-APRXV*/))){ // Se la diferenza tra i due rige orizontali  menore di HTARGA
                              // Ordena i due rige orizontali
                              if(maximos_filas[i]>maximos_filas[j]){
                                inicio=maximos_filas[j];
                                fin=maximos_filas[i];
                              }else{
                                inicio=maximos_filas[i];
                                fin=maximos_filas[j];
                              }      
                              sumaCol(img,suma2,inicio,fin);
                              n_max(suma2,DIM_X,maximos,num_max);
                              media(5,DIM_X,suma2,suma);
                              // Prende le rige verticali massime, fa una media movile e le scrive in suma
                              for(cont1=0;cont1<num_max;cont1++)for(cont2=cont1;cont2<num_max;cont2++)if(maximos[cont1]!=-1 && maximos[cont2]!=-1){
                                     if((abs(maximos[cont1]-maximos[cont2])<(WTARGA+APRX)) && (abs(maximos[cont1]-maximos[cont2])>(WTARGA/*-APRX*/))){      
                                     //  un rettangolo possibile per le dimensioni
                                         int lineaH=0;
                                         int desv1=0;
                                         int lineaH2=0;
                                         int desv2=0;
                                         int p;
                                         int kk;
                         
                                         if(maximos[cont1]<maximos[cont2]){
                                             for(p=maximos[cont1];p<maximos[cont2];p++)for(kk=0;kk<3;kk++)lineaH+= imH[m(maximos_filas[i],p,kk)]; 
                                             for(p=maximos[cont1];p<maximos[cont2];p++)for(kk=0;kk<3;kk++)lineaH2+= imH[m(maximos_filas[j],p,kk)];
                                             lineaH/=((abs(maximos[cont1]-maximos[cont2]))*3);
                                             lineaH2/=((abs(maximos[cont1]-maximos[cont2]))*3);
                                             for(p=maximos[cont1];p<maximos[cont2];p++)for(kk=0;kk<3;kk++)desv1+= abs(imH[m(maximos_filas[i],p,kk)]-lineaH);                                                                        
                                             for(p=maximos[cont1];p<maximos[cont2];p++)for(kk=0;kk<3;kk++)desv2+= abs(imH[m(maximos_filas[i],p,kk)]-lineaH2);
                                         }else{
                                             for(p=maximos[cont2];p<maximos[cont1];p++)for(kk=0;kk<3;kk++)lineaH+= imH[m(maximos_filas[i],p,kk)];  
                                             for(p=maximos[cont2];p<maximos[cont1];p++)for(kk=0;kk<3;kk++)lineaH2+= imH[m(maximos_filas[j],p,kk)];
                                             lineaH/=((abs(maximos[cont1]-maximos[cont2]))*3);
                                             lineaH2/=((abs(maximos[cont1]-maximos[cont2]))*3);      
                                             for(p=maximos[cont2];p<maximos[cont1];p++)for(kk=0;kk<3;kk++)desv1+= abs(imH[m(maximos_filas[i],p,kk)]-lineaH);                                                                        
                                             for(p=maximos[cont2];p<maximos[cont1];p++)for(kk=0;kk<3;kk++)desv2+= abs(imH[m(maximos_filas[i],p,kk)]-lineaH2); 
                                         }
                                         desv1/=((abs(maximos[cont1]-maximos[cont2]))*3);
                                         desv2/=((abs(maximos[cont1]-maximos[cont2]))*3);
                                         if(lineaH>SOGLIA && lineaH2>SOGLIA){
                                             coloraux=color_medio(img,maximos[cont1],maximos[cont2],maximos_filas[i],maximos_filas[j]);
                                             if(coloraux>color && coloraux>SOGLIACOLOR){
                                             // Rettangolo massimo in questo momento
                                                      color=coloraux;
                                                      linea1=maximos_filas[i];
                                                      linea2=maximos_filas[j];
                                                      col1=maximos[cont1];
                                                      col2=maximos[cont2];
                                             }
                                             if(coloraux>SOGLIACOLOR){      
                                             // Disegna una possibile targa                                                  
                                                       dibuja_col(dest,maximos[cont1],maximos_filas[i],maximos_filas[j]);
                                                       dibuja_col(dest,maximos[cont2],maximos_filas[i],maximos_filas[j]);
                                                       dibuja_fil(dest,maximos_filas[i],maximos[cont1],maximos[cont2]);
                                                       dibuja_fil(dest,maximos_filas[j],maximos[cont1],maximos[cont2]);
                                                       if(spint[0]>maximos[cont1])
                                                         spint[0]=maximos[cont1];
                                                       if(spint[1]<maximos[cont2])
                                                         spint[1]=maximos[cont2];
                                                       if(spint[2]>maximos_filas[i])
                                                         spint[2]=maximos_filas[i];
                                                       if(spint[3]<maximos_filas[j])
                                                         spint[3]=maximos_filas[j];
//                                                       targa[contatore].sx=maximos[cont1];
//                                                       targa[contatore].dx=maximos[cont2];
//                                                       targa[contatore].up=maximos_filas[i];
//                                                       targa[contatore].down=maximos_filas[j];

                                                       layout(contatore,maximos[cont1],maximos[cont2],maximos_filas[i],maximos_filas[j]);
                                                       contatore++;
                                             }
                                         }
                                     }
                                     
                              }                             
                          //}  
             }                            
         }        
     }
  if(color>0){
                if(linea1<linea2){
                    fini=linea1;
                    ffin=linea2;
                }else{
                    fini=linea2;
                    ffin=linea1;
                }
                
                d=distanciaVecina(maximos_filas,num_max_filas,fini);
                if((fini-maximos_filas[d])<8)fini=maximos_filas[d];{
                  dibujar_cuadrado(dest,fini,ffin,col1,col2,1);
                  printf("\nfini %d ffin %d col1 %d col2 %d\n",fini,ffin,col1,col2);
                }
                // Disegna il rettangolo con il massimo colore mezzo si  trovato (il massimo colore mezzo  superiore a SOGLIACOLOR
                
  }
}



int distanciaVecina(int fila[],int nf,int f){
    int i;
    int res=f;
    int distancia=99999;
    for(i=0;i<nf;i++){
        if(fila[i]<f && fila[i]!=f && (f-fila[i])<distancia){
            distancia=f-fila[i];
            res=i;
        }
    }
    return res;
}


/*
  Disegna 'num_max' rige verticali secondo l'array 'maximos' nella immagine img
  img:              immagine origine
  num_max:          numero di rige verticaliche si vuole disegnare (size dell'array 'maximos_fil')
  maximos:          array con i posizioni dei rige che si restituiscono
  num_max_fil:      size dell'array 'maximos_fil'
  maximos_fil:      array con i massimi rige
*/
void lineas_verticales(unsigned char* img,int num_max,int maximos[],int num_max_fil,int maximos_fil[]){
     int i,j,k,canal,cont,inicio,fin;
     for(i=0;i<num_max_fil;i++)for(j=i;j<num_max_fil;j++){
                   if((abs(maximos_fil[i]-maximos_fil[j])<(HTARGA+5)) && (abs(maximos_fil[i]-maximos_fil[j])>(HTARGA-5))){
                              if(maximos_fil[i]>maximos_fil[j]){
                                inicio=maximos_fil[j];
                                fin=maximos_fil[i];
                              }else{
                                inicio=maximos_fil[i];
                                fin=maximos_fil[j];
                              }
                              for(cont=0;cont<num_max;cont++)
                              for(canal=0;canal<CHANNELS;canal++)
                              for(k=inicio;k<fin;k++){
                                if(maximos[cont]>0 && maximos[cont]<639)
                                img[m(k,maximos[cont],canal)]=255;
                              }
                   }
     }
     
}

/*
  Fa il gradente verticale all'immagine 'img' e lo restituisce in 'dest'
  img:  immagine origine
  dest: immagine destino
*/
void gradiente_vertical(unsigned char* img, unsigned char* dest){
    int i,j,k,aux;
    for(i=0;i<DIM_Y;i++) for(j=0;j<DIM_X;j++) for(k=0;k<CHANNELS;k++){
       aux=abs(img[m(i,j,k)]-img[m(i+1,j,k)]);
       dest[m(i,j,k)]=funcion(aux);
    }
}

/*
  Restituisce in 'maximos' i 'num_max' massimi locali dei sommatori de riga orizontale ordinati di menore a maggiore
  img:        immagine a tratar
  num_max:    size di 'maximos'
  maximos:    array dove si vuole restituire i massimi
*/
void max_lineas(unsigned char* img,int num_max,int maximos[]){
     int i;
     int suma[DIM_Y];
     int suma2[DIM_Y];
     for(i=0;i<num_max;i++)maximos[i]=-1;
     sumaFil(img,suma);
     media(5,DIM_Y,suma,suma2);
     n_max(suma2,DIM_Y,maximos,num_max);
}

/*
  Disegna 'num_max' rige orizontali nella immagine 'img' secondo l'array 'maximos'
  img:              immagine origine
  num_max:          size di 'maximos'
  maximos:          array dove si vuole restituire le rige
*/
void lineas_horizontales(unsigned char* img,int num_max,int maximos[]){
     int i,j,k,cont;

    for(j=0;j<DIM_X;j++)for(k=0;k<CHANNELS;k++)for(cont=0;cont<num_max;cont++){
    img[m(maximos[cont],j,k)]=255;
    }
     
}

//dest deve essere un'immagine tutta nera
void layout(int cont,int hor1,int hor2,int vert1,int vert2){
int i,j;
 int inic1,inic2,fin1,fin2;
 if(vert1>vert2){
     inic1=vert2;
     fin1=vert1;
 }else{
       inic1=vert1;
       fin1=vert2;
 }
 if(hor1>hor2){
       inic2=hor2;
       fin2=hor1;
 }else{inic2=hor1;fin2=hor2;}
 
     targa[cont].sx=inic2;
     targa[cont].dx=fin2;
     targa[cont].up=inic1;
     targa[cont].down=fin1;
/*     
     for(i=inic1;i<fin1;i++){
           for(j=inic2;j<fin2;j++)
             dest[m(i,j,1)]=1;
     }
*/
//   int i,j;
//     for(i=y1;i<=y2;i++)
//       for(j=x1;j<=x2;j++)
//         dest[DIM_X*i+j]=img[DIM_X*i+j];

}

/////////////                           OK                 /////////////////



void plate_detection(uchar* image,unsigned char*black,unsigned char * im,int width, int height)
{
	
  int x,y;	
  int num_max_lineas          =15;       // Numero massimo di rige orizontale che si vuole prendere dil gradiente verticale
  int num_max_col             =31;       // Numero massimo di rige verticale che si vuole prendere dil gradiente orizontale
  int maximos_lineas[15];                // Array che contene i rige orizontali, deve avere dimensione 'num_max_lineas'    
  int maximos_columnas[31];              // Array che contene i rige verticali, deve avere dimensione 'num_max_col'

  interpolation(im,data2,H);                 // Restituisce in data2 l'homography di im, comentare se non si vuole fare l'homography
  interpolation(im,image,H);
//  memcpy(data2,im,sizeof(data2));              // Copia in data2 il contenuto di im comentare si se vuole fare l'homography

  gradiente_vertical(data2,data3);             // Restituisce in data3 il gradiente verticale della immagine data2
  gradiente_horizontal(data2,data1);            // Restituisce in data1 il gradiente orizontale della immagine data2 
 
  max_lineas(data3,num_max_lineas,maximos_lineas);  // Scrive in 'maximos_lineas' i 'num_max_lineas' massime rige orizontale dil gradiente verticale
  max_columnas(image, black,data1,data2,num_max_col,maximos_columnas,num_max_lineas,maximos_lineas,data3); // Disegna in data2 i rettangoli (possibili targhe) dati per maximos_columnas e maximos lineas
  printf("\npossibili targhe trovate: %d\n",contatore);
  memcpy(im,data2,sizeof(data2));        // copia in im la immagine data2, che ha i rettangoli disegnati	
}

int* ret_spint(){
return spint;
}

/*
void print_merge(uchar* image){
  int i,j,k;
  ordina_targa();
  for(k=contatore-1;k>contatore-20;k--)
    for(i=targa[k].up;i<=targa[k].down;i++)
      for(j=targa[k].sx;j<=targa[k].dx;j++)
        image[DIM_X*i+j]=targa[k].val;

}
*/

/*void ordina_targa(){
 int n;
 int i,j,val;
 n=contatore;
 for(i=1;i<n;i++)
 {
   val=targa[i].val;
 for(j=i;j>0 && targa[j-1].val>val;j--)
   {
     targa[j].val=targa[j-1].val;
   }
   targa[j].val=val;
 } 
}

*/

