#ifndef _DetectionFunc_h_included_
#define _DetectionFunc_h_included_

/******************************************************************************
* INCLUDES                                                                    *
******************************************************************************/

//#include <cv.h>
//#include <highgui.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>



/******************************************************************************
* DEFINITIONS                                                                 *
******************************************************************************/
#define DIM_X 640
#define DIM_Y 480
#define  STEP         1920
#define  CHANNELS     1

/******************************************************************************
* TYPEDEF                                                                     *
******************************************************************************/
typedef struct pixel{ //struttura per la floodfillMask
  int sx;
  int dx;
  int up;
  int down;
  int count;  
}PIXEL;

typedef struct targa{ //struttura per la floodfillMask
  int sx;
  int dx;
  int up;
  int down;
  int val;  
}TARGA;

typedef struct elem{
  int x,y;  
}ELEM;


typedef unsigned char uchar;




/******************************************************************************
* FUNCTIONS' PROTOTYPES                                                       *
*                                                                             *
* the input for each function is:                                             *
* - one or more copies of the original image                                  *
* - dimentions (hight and width)                                              *
* - closure window dimention                                                  *
******************************************************************************/



int     get_l_closure();
int     get_n_closure();
uchar*  transform(uchar*, uchar*, int, int);

uchar*  equalization(uchar* equalized, int dim_x, int dim_y);
uchar*  convolution(uchar* convoluted, int dim_x, int dim_y);

uchar*  dilate(uchar* image, uchar* half_dilate, uchar* dilate_out, int dim_x, int dim_y, int l, int n);
uchar*  erode(uchar* erode_in, uchar* half_erode, uchar* erode_out, int dim_x, int dim_y, int l, int n);
int     negative(uchar* src, int x, int y);

uchar*  whiteMask(uchar* image1, uchar* half, uchar* endout, int dim_x, int dim_y, int l, int n);
uchar*  blackMask(uchar* image2, uchar* half, uchar* end_out, int dim_x, int dim_y, int l, int n);
uchar*  gradientMask(uchar* image, uchar* gradient, uchar* half, uchar* end_out, int *half_gradient, int dim_x, int dim_y, int l, int n);
uchar*  cornerMask(uchar* image, uchar* corner, uchar* half, uchar* end_out, int *half_corner, int dim_x, int dim_y, int l, int n);
uchar*  strokeMask(uchar* image, uchar* stroke, uchar* image11, uchar* half, uchar* end_out, int dim_x, int dim_y, int l, int n);

uchar*  mergingMask(uchar* image9,uchar* selection, uchar* white, uchar* black, uchar* gradient, uchar* corner, uchar* stroke, int dim_x, int dim_y);
uchar*  finalMask (uchar* image, uchar* merging, uchar* half, uchar* end_out, int dim_x, int dim_y, int l, int n);
uchar*  binarizedMask(uchar* final, uchar* binarized, int dim_x, int dim_y);
uchar*  thresholdingMask(uchar* binarized, uchar* image11, uchar* thresholding, int dim_x, int dim_y);
void floodFillMask(uchar *image);
uchar*  closure_binarizedMask(uchar* thresholding, uchar* closure_binarized_dilate, uchar* closure_binarized, int dim_x, int dim_y);

uchar* print_blob(uchar* image, uchar* temp,int x1,int x2,int y1,int y2);

/////////////////////////parte spagnola/////////////////////////////



  // Soglia dei gradenti

/*
  Funzione ausiliare
*/
int mul(float decx,float decy,int x, int y, unsigned char* img,int k);

/*
  Restituisce il num-essimo valore dell'array 'array' con size 'tamarray'
  num:        posizione desiderata
  tamarray:   size dell'array
  array:      Array del quale si vuole prendere un valore
*/
int obtener(int num, int tamarray,int array[]);

/*
  Fa una media mobile da 'media' in 'media' dil array 'suma' e lo restituisce in 'suma2'
  media:       Prende i 'media' valori per fare la media
  tamsuma:     Size degli array
  suma:        Array origine
  suma2:       Array dove si restituisce la media
*/
void media(int media,int tamsuma,int suma[],int suma2[]);

/*
  Restituisce la posizione del pixel con 'i' Height, 'j' Width y 'k' Channel
  Se esce dei limiti, restituisce il pixel del limite.
  Se se vuole fare in OpenCV si deve scomentare una riga di sotto e comentare un'altra
  i: Height
  j: Width
  k: Channel
*/
int m(int i,int j, int k);
/*
  Restituisce in Dest l'immagine img con l'homography fatta secondo la matrice 3x3 invT con
  il metodo nearest neightbour
  img:      immagine origine
  dest:     immagine destino
  invT:     Matrice H della homography
*/
void homography(unsigned char* img, unsigned char* dest, float invT[3][3]);

/*
  Restituisce in Dest l'immagine img con l'homography fatta secondo la matrice 3x3 invT con
  il metodo interpolation
  img:      immagine origine
  dest:     immagine destino
  invT:     Matrice H della homography
*/
void interpolation(unsigned char* img, unsigned char* dest, float invT[3][3]);

/*
  Disegna una riga verticale dal punto 'desde' fino 'hasta' nella posizione 'col'
  img:    img origine
  col:    posizione della riga verticale che si vuole disegnare
  desde:  posizione orizontale d'inizio dove si vuole disegnare la riga verticale
  hasta:  posizione orizontale finale dove si vuole disegnare la riga verticale
*/
void dibuja_col(unsigned char* img, int col, int desde, int hasta);
/*
  Disegna una riga orizontale dal punto 'desde' fino 'hasta' nella posizione 'fil'
  img:    img origine
  fil:    posizione della riga orizontale che si vuole disegnare
  desde:  posizione verticale d'inizio dove si vuole disegnare la riga orizontale
  hasta:  posizione verticale finale dove si vuole disegnare la riga orizontale
*/
void dibuja_fil(unsigned char* img,int fil,int desde,int hasta);
/*
  Restituisce in 'suma', per ogni posizione 'i', la somma della riga verticale numero 'i'
  img:        immagine origine
  suma:       array dove si restituisce la somma dei rige verticali della immagine
  desde:      posizione verticale d'inizio
  hasta:      posizione verticale finale
*/
void sumaCol(unsigned char* img,int suma[DIM_X],int desde,int hasta);
/*
  Restituisce in 'suma', per ogni posizione 'i', la somma della riga orizontale numero 'i'
  img:        immagine origine
  suma:       array dove si restituisce la somma dei rige orizontali della immagine
  desde:      posizione orizontale d'inizio
  hasta:      posizione orizontale finale
*/
void sumaFil(unsigned char* img,int suma[DIM_Y]);

/*
  ordina l'array 'maximos', secondo il contenuto di 'somma'   (suma[maximos[i]])
  suma:          array con i sommi
  maximos:       array dove si restituisce i massimi valori di 'suma' ordinati
  length:        size dell'array 'maximos'
*/
void ordenar(int suma[],int maximos[],int length);

/*
  funzione ausiliare della funzione 'hay_sitio', restituisce la posizione dove sta il numero 'num' nell'array 'maximos'
  se non lo trova restituisce -1
  maximos:  array dove si cerca il numero 'num'
  length:   size dell'array 'maximos'
  num:      numero a trovare
*/
int esta(int maximos[],int length,int num);
/*
  Restituisce 1 se el numero 'numero'  un massimo del array 'suma' di grandeza 'tamsum', 
  se non  un massimo restituisce -1
  suma:    array inserito
  tamsum:  size dell'array
  numero:  numero dil quale si vuole sapere se  un massimo
*/
int es_max(int suma[],int tamsum,int numero);
/*
  Funzione ausiliare della funzione 'n_max',
  restituisce la posizione dove si pu inserire il numero 'numero' nell'array 'maximos', che  ordinato
  secondo il contenuto di 'suma'. Se non si pu inserire, restituisce -1.
  maximos:   Array dove si vuole inserire il numero
  suma:      'Maximos'  ordinato secondo questo contenito
  tamsum:    size di 'suma'
  length:    size di 'maximos'
  numero:    numero che si vuole inserire
*/
int hay_sitio(int suma[],int tamsum,int numero,int maximos[],int length);

/*
  Restituisce in 'maximos', los 'n' massimi numeri ordinati secondo il contenuto di 'suma'
  suma:       array di dove su vole prendere i massimi
  tamsum:     size di 'suma'
  maximos:    dove si vuole restituire i massimi
  n:          numero di massimi che si vuole prendere
*/
void n_max(int suma[],int tamsum,int maximos[],int n);
/*
  Funzione che s'applica ai numeri dei gradente
  num:     pixel al qual si vuole applicare una funzione
*/
int funcion(int num);

/*
  Fa il gradente orizontale all'immagine 'img' e lo restituisce in 'dest'
  img:  immagine origine
  dest: immagine destino
*/
void gradiente_horizontal(unsigned char* img, unsigned char* dest);
/*
  Disegna un rettangolo con le quatro rige, due verticali (vert1 e vert2) e due orizontali (hor1 e hor2), canal
  e il canale RGB dove si vuole disegnare il rettangolo
  img:        immagine dove si vuole disegnare il rettangolo
  vert1:      riga verticale 1
  vert2:      riga verticale 2
  hor1:       riga orizontale 1
  hor2:       riga orizontale 2
  canal:      canal dove si vuole disegnare (RGB)
*/
void dibujar_cuadrado(unsigned char*img,int vert1,int vert2,int hor1,int hor2,int canal);
/*
  Restituisce il colore mezzo del rettangolo dato per i quatro rige che lo delimitano (col1,col2,fil1 e fil2)
  img:        immagine origine
  col1:       riga verticale 1
  col2:       riga verticale 2
  fil1:       riga orizontale 1
  fil2:       riga orizontale 2
*/
int color_medio(unsigned char* img,int col1,int col2,int fil1,int fil2);

/*
  Prende la immagine img e restituisce in dest la stessa immagine con le possibili targhe
  
  img:           immagine origine
  dest:          immagine destino (dove sono disegnati le possibili targhe)
  num_max:       size del array maximos2
  maximos2:      Array con i 'num_max' massimi rige verticali 
  num_max_filas: size dell'array 'maximos_filas'
  maximos_filas: Array con i 'num_max_filas' massimi rige orizontali
  imH:           Immagine con il Gradiente Verticale
*/
void max_columnas(uchar * image,unsigned char*black,unsigned char*img,unsigned char*dest,int num_max,int maximos2[],int num_max_filas,int maximos_filas[],unsigned char* imH);

/*
  Disegna 'num_max' rige verticali secondo l'array 'maximos' nella immagine img
  img:              immagine origine
  num_max:          numero di rige verticaliche si vuole disegnare (size dell'array 'maximos_fil')
  maximos:          array con i posizioni dei rige che si restituiscono
  num_max_fil:      size dell'array 'maximos_fil'
  maximos_fil:      array con i massimi rige
*/
void lineas_verticales(unsigned char* img,int num_max,int maximos[],int num_max_fil,int maximos_fil[]);

int distanciaVecina(int fila[],int nf,int f);
/*
  Fa il gradente verticale all'immagine 'img' e lo restituisce in 'dest'
  img:  immagine origine
  dest: immagine destino
*/
void gradiente_vertical(unsigned char* img, unsigned char* dest);

/*
  Restituisce in 'maximos' i 'num_max' massimi locali dei sommatori de riga orizontale ordinati di menore a maggiore
  img:        immagine a tratar
  num_max:    size di 'maximos'
  maximos:    array dove si vuole restituire i massimi
*/
void max_lineas(unsigned char* img,int num_max,int maximos[]);
/*
  Disegna 'num_max' rige orizontali nella immagine 'img' secondo l'array 'maximos'
  img:              immagine origine
  num_max:          size di 'maximos'
  maximos:          array dove si vuole restituire le rige
*/
void lineas_horizontales(unsigned char* img,int num_max,int maximos[]);


void plate_detection(uchar *image, unsigned char* black,unsigned char * imBuff,int width, int height);



void layout(int cont,int hor1,int hor2,int vert1,int vert2);

void print_merge(uchar* image);
     
int* ret_spint();

void ordina_targa();


#endif




