/******************************************************************************
* INCLUDES                                                                    *
******************************************************************************/

#include "PlateMain.h"
#include "DetectionFunc.h"

/******************************************************************************
* GLOBAL DECLARATIONS                                                         *
******************************************************************************/
IplImage* img = 0;
int buffer_image[DIM_X*DIM_Y];                           //temporary buffer
uchar buffer[DIM_X*DIM_Y];                     //temporary buffer
uchar buffer1[DIM_X*DIM_Y];                     //temporary buffer

/******************************************************************************
* MAIN FUNCTION                                                               *
*                                                                             *
* the input is:                                                               *
* - name of the original picture (e.g. "pic_name.jpg")                        *
* - [optional] text file with new parameters (e.g. "param_file.txt")          *
*                                                                             *
******************************************************************************/

int main(int argc, char* argv[])  //riceve in ingresso il nome della foto come nome_foto.jpg
                                  //eventualmente il file di testo con i parametri del programma come nome_file.txt
{
  IplImage* orig_src[6]   = {0,0,0,0,0,0};
  IplImage* src[9]   = {0,0,0,0,0,0,0,0,0};
  IplImage* img_half    = 0;        //di supporto
  IplImage* img_end_out = 0;        //di supporto
  
  float H[3][3]={ { 0.1734  ,  0.0318, 0.3022},
                {-0.0402  ,  0.2116, 0.8931},
                {-0.0000  ,  0.0000, 0.1832}};// Matrice H necessaria per fare l'homography
  
  
  int       l,n;                    //variabili da inizializzare con la larghezza e altezza della finestra della closure 
  
  char*     filename;               //nome della foto originale
  char      nome_foto [100];        //nome della foto originale senza estensione (.jpg)
  filename = argv[1];
  int p; 
  for(p=0; filename[p]!='.'; p++)   //scrivo in nome_foto il valore di filename fino al punto, in modo da togliere l'estensione
    nome_foto[p]=filename[p];
  nome_foto[p]='\0';

  //caricamento dell'immagine originale in varie copie
  for(p=0; p<6; p++) { 
    if( (orig_src[p] = cvLoadImage(filename,-1)) == 0 ) return -1;
    src_image[p] = (uchar*)orig_src[p]->imageData;
  }
  
  int i,j;
  for(i=0;i<DIM_Y;i++)
    for(j=0;j<DIM_X;j++)
      src_image[0][DIM_X*i+j]=0;

//Convolvo ed Equalizzo il sorgente e faccio l'omografia
interpolation(src_image[4],src_image[3],H);
src_image[3]=equalization(src_image[3],DIM_X,DIM_Y);
src_image[3]=convolution(src_image[3],DIM_X,DIM_Y);
src_image[5]=equalization(src_image[5],DIM_X,DIM_Y);
src_image[5]=convolution(src_image[5],DIM_X,DIM_Y);

               //HO FINITO DI CARICARE LE IMMAGINI//



                    
//  printf("Spain Mask\n");  
  strcpy(filename_out,nome_foto);
  plate_detection(src_image[2],src_image[0],(uchar*)orig_src[1] -> imageData,DIM_X,DIM_Y);
  strcat(filename_out,"_01_spain Mask.jpg");                     
  cvSaveImage(filename_out, orig_src[1]);                            

//  printf("Crea sorgente\n");  
  strcpy(filename_out,nome_foto);
  strcat(filename_out,"_02_src.jpg");                     
  cvSaveImage(filename_out, orig_src[3]);
  
               //HO TROVATO LE POSSIBILI AREE DELLE TARGHE//
               //ADESSO LE ANALIZZO CON L'ALTRO ALGORITMO//
  
  
  for(p=0; p<9; p++) { 
    if( (src[p] = cvLoadImage(filename_out,-1)) == 0 ) return -1;
    image[p] = (uchar*)src[p]->imageData;
  }
  if( (img_half    = cvLoadImage(filename_out,-1)) == 0 ) return -1;
  if( (img_end_out = cvLoadImage(filename_out,-1)) == 0 ) return -1;    

  half    = (uchar*)img_half    ->imageData;
  end_out = (uchar*)img_end_out ->imageData;

  l       = get_l_closure();                      //assegnamento a l della larghezza della finestra con cui fare dilate/erode
  n       = get_n_closure();                      //assegnamento a n dell'altezza della finestra con cui fare dilate/erode
  
 
  //HO LE IMMAGINI E I DATI SUI QUALI LAVORARE//
  
  /******************************************************************************
* WHITE MASK                                                                  *
******************************************************************************/
//  printf("White Mask\n");  
  strcpy(filename_out,nome_foto);
  white = whiteMask(image[0], half, end_out, DIM_X, DIM_Y, l, n); 
  strcat(filename_out,"_03_White Mask.jpg");                     
  src[0]->imageData=(char*)white;  
  cvSaveImage(filename_out, src[0]);                            


/******************************************************************************
* BLACK MASK                                                                  *
******************************************************************************/
//  printf("Black Mask\n");  
  strcpy(filename_out,nome_foto);
  black  = blackMask(image[1], half, end_out, DIM_X, DIM_Y, l, n);
  strcat(filename_out,"_04_Black Mask.jpg");
  src[1]->imageData=(char*)black;  
  cvSaveImage(filename_out, src[1]);


/******************************************************************************
* GRADIENT MASK                                                               *
******************************************************************************/
//  printf("Gradient Mask\n");  
//sono commentati gli originali dove viene calcolato il gradiente sull'immagine trasformata

  strcpy(filename_out,nome_foto);
//  gradient = gradientMask(image[2], buffer1, half, end_out, buffer_image, DIM_X, DIM_Y, l, n);
  gradient = gradientMask(src_image[5], buffer1, half, end_out, buffer_image, DIM_X, DIM_Y, l, n);
  strcat(filename_out,"_05_Gradient Mask.jpg");
//  cvSaveImage(filename_out, src[2]);

//adesso la raddrizzo
  interpolation(src_image[5],src_image[4],H);
  gradient=src_image[4];
  cvSaveImage(filename_out, orig_src[4]);

/******************************************************************************
* CORNER MASK                                                                 *
******************************************************************************/ 
//  printf("Corner Mask\n");  
  strcpy(filename_out,nome_foto);
  corner = cornerMask  (image[3], buffer1, half, end_out, buffer_image, DIM_X, DIM_Y, l, n);
  strcat(filename_out,"_06_Corner Mask.jpg");
  cvSaveImage(filename_out, src[3]);


/******************************************************************************
* STROKE MASK                                                                 *
******************************************************************************/
//  printf("Stroke Mask\n");  
  strcpy(filename_out,nome_foto);
  stroke  = strokeMask  (image[4], image[5], image[6], half, end_out, DIM_X, DIM_Y, l, n);
  strcat(filename_out,"_07_Stroke Mask.jpg");
  cvSaveImage(filename_out, src[5]);


/******************************************************************************
* MERGING MASK                                                                *
******************************************************************************/     
//  printf("Merging Mask\n");
  strcpy(filename_out,nome_foto);
  merging = mergingMask(buffer,src_image[0], white, black, gradient, corner, stroke, DIM_X, DIM_Y);
  strcat(filename_out,"_08_Merging Mask.jpg");
  src[0]->imageData=(char*)merging;               //serve solo per la visualizzazione
  cvSaveImage(filename_out, src[0]);


/******************************************************************************
* FINAL MASK                                                                  *
******************************************************************************/
//  printf("Final Mask\n");
  strcpy(filename_out,nome_foto);
  final = finalMask(buffer, merging, half, end_out, DIM_X, DIM_Y, l, n);
  strcat(filename_out,"_09_Final Mask.jpg");
  src[1]->imageData=(char*)final;               //serve solo per la visualizzazione
  cvSaveImage(filename_out, src[1]);


/******************************************************************************
* BINARIZED MASK                                                              *
******************************************************************************/ 
//  printf("Binarized Mask\n");
  strcpy(filename_out,nome_foto);
  binarized = binarizedMask(final, buffer1, DIM_X, DIM_Y);
  strcat(filename_out,"_10_Binarized Mask.jpg");
  src[2]->imageData=(char*)binarized;               //serve solo per la visualizzazione
  cvSaveImage(filename_out, src[2]);


/******************************************************************************
* THRESHOLDING MASK                                                           *
******************************************************************************/
//  printf("Thresholding Mask\n");
  strcpy(filename_out,nome_foto);
  thresholding = thresholdingMask(binarized, image[6], buffer, DIM_X, DIM_Y);
  strcat(filename_out,"_11_Thresholding Mask.jpg");
  src[3]->imageData=(char*)thresholding;               //serve solo per la visualizzazione
  cvSaveImage(filename_out, src[3]);


/******************************************************************************
* CLOSURE BINARIZED MASK                                                      *
******************************************************************************/
//  printf("Closure Binarized Mask\n");
  strcpy(filename_out,nome_foto);
  closure_binarized = closure_binarizedMask(thresholding, buffer1, buffer, DIM_X, DIM_Y);
  strcat(filename_out,"_13_Closure_binarized Mask.jpg");
  src[4]->imageData=(char*)closure_binarized;               //serve solo per la visualizzazione
  cvSaveImage(filename_out, src[4]);
  

/******************************************************************************
* FLOOD FILL MASK                                                             *
******************************************************************************/
//  printf("Fill Mask\n");
//  strcpy(filename_out,nome_foto);
//  floodFillMask(closure_binarized);
//  (closure_binarized, image[6], buffer_image, DIM_X, DIM_Y)
//  strcat(filename_out,"_12_Flood Fill Mask.jpg");
//  cvSaveImage(filename_out, src[11]);

   return 0;

}







/* END OF MAIN                                                                *
******************************************************************************/



/******************************************************************************
* INTERNAL FUNCTIONS                                                          *
******************************************************************************/

